# coding: utf-8

"""
    The Selling Partner API for Invoices.

    Use the Selling Partner API for Invoices to retrieve and manage invoice-related operations, which can help selling partners manage their bookkeeping processes.

    The version of the OpenAPI document: 2024-06-19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.InvoicesApiModel_2024_06_19.models.export_status import ExportStatus
from typing import Optional, Set
from typing_extensions import Self

class Export(BaseModel):
    """
    Detailed information about the export.
    """ # noqa: E501
    error_message: Optional[StrictStr] = Field(default=None, description="When the export generation fails, this attribute contains a description of the error.", alias="errorMessage")
    export_id: Optional[StrictStr] = Field(default=None, description="The export identifier.", alias="exportId")
    generate_export_finished_at: Optional[datetime] = Field(default=None, description="The date and time when the export generation finished. Vales are in [ISO 8601](https://developer-docs.amazon.com/sp-api/docs/iso-8601) date-time format.", alias="generateExportFinishedAt")
    generate_export_started_at: Optional[datetime] = Field(default=None, description="The date and time when the export generation started. Values are in [ISO 8601](https://developer-docs.amazon.com/sp-api/docs/iso-8601) date-time format.", alias="generateExportStartedAt")
    invoices_document_ids: Optional[List[StrictStr]] = Field(default=None, description="The identifier for the export documents. To get the information required to retrieve the export document's contents, pass each ID in the `getInvoicesDocument` operation.  This list is empty until the status is `DONE`.", alias="invoicesDocumentIds")
    status: Optional[ExportStatus] = None
    __properties: ClassVar[List[str]] = ["errorMessage", "exportId", "generateExportFinishedAt", "generateExportStartedAt", "invoicesDocumentIds", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Export from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Export from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "errorMessage": obj.get("errorMessage"),
            "exportId": obj.get("exportId"),
            "generateExportFinishedAt": obj.get("generateExportFinishedAt"),
            "generateExportStartedAt": obj.get("generateExportStartedAt"),
            "invoicesDocumentIds": obj.get("invoicesDocumentIds"),
            "status": obj.get("status")
        })
        return _obj


