# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.aplusContent_2020_11_01.models.content_module import ContentModule
from py_sp_api.generated.aplusContent_2020_11_01.models.content_type import ContentType
from typing import Optional, Set
from typing_extensions import Self

class ContentDocument(BaseModel):
    """
    The A+ Content document. This is the enhanced content that is published to product detail pages.
    """ # noqa: E501
    name: Annotated[str, Field(min_length=1, strict=True, max_length=100)] = Field(description="The A+ Content document name.")
    content_type: ContentType = Field(alias="contentType")
    content_sub_type: Optional[Annotated[str, Field(min_length=1, strict=True)]] = Field(default=None, description="The A+ Content document subtype. This represents a special-purpose type of an A+ Content document. Not every A+ Content document type will have a subtype, and subtypes may change at any time.", alias="contentSubType")
    locale: Annotated[str, Field(min_length=5, strict=True)] = Field(description="The IETF language tag. This only supports the primary language subtag with one secondary language subtag. The secondary language subtag is almost always a regional designation. This does not support additional subtags beyond the primary and secondary subtags. **Pattern:** ^[a-z]{2,}-[A-Z0-9]{2,}$")
    content_module_list: Annotated[List[ContentModule], Field(min_length=1, max_length=100)] = Field(description="A list of A+ Content modules.", alias="contentModuleList")
    __properties: ClassVar[List[str]] = ["name", "contentType", "contentSubType", "locale", "contentModuleList"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ContentDocument from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in content_module_list (list)
        _items = []
        if self.content_module_list:
            for _item_content_module_list in self.content_module_list:
                if _item_content_module_list:
                    _items.append(_item_content_module_list.to_dict())
            _dict['contentModuleList'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ContentDocument from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "contentType": obj.get("contentType"),
            "contentSubType": obj.get("contentSubType"),
            "locale": obj.get("locale"),
            "contentModuleList": [ContentModule.from_dict(_item) for _item in obj["contentModuleList"]] if obj.get("contentModuleList") is not None else None
        })
        return _obj


