# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.aplusContent_2020_11_01.models.content_document import ContentDocument
from py_sp_api.generated.aplusContent_2020_11_01.models.content_metadata import ContentMetadata
from typing import Optional, Set
from typing_extensions import Self

class ContentRecord(BaseModel):
    """
    A content document with additional information for content management.
    """ # noqa: E501
    content_reference_key: Annotated[str, Field(min_length=1, strict=True)] = Field(description="A unique reference key for the A+ Content document. A content reference key cannot form a permalink and may change in the future. A content reference key is not guaranteed to match any A+ content identifier.", alias="contentReferenceKey")
    content_metadata: Optional[ContentMetadata] = Field(default=None, alias="contentMetadata")
    content_document: Optional[ContentDocument] = Field(default=None, alias="contentDocument")
    __properties: ClassVar[List[str]] = ["contentReferenceKey", "contentMetadata", "contentDocument"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ContentRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of content_metadata
        if self.content_metadata:
            _dict['contentMetadata'] = self.content_metadata.to_dict()
        # override the default output from pydantic by calling `to_dict()` of content_document
        if self.content_document:
            _dict['contentDocument'] = self.content_document.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ContentRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contentReferenceKey": obj.get("contentReferenceKey"),
            "contentMetadata": ContentMetadata.from_dict(obj["contentMetadata"]) if obj.get("contentMetadata") is not None else None,
            "contentDocument": ContentDocument.from_dict(obj["contentDocument"]) if obj.get("contentDocument") is not None else None
        })
        return _obj


