# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.aplusContent_2020_11_01.models.plain_text_item import PlainTextItem
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_comparison_product_block import StandardComparisonProductBlock
from typing import Optional, Set
from typing_extensions import Self

class StandardComparisonTableModule(BaseModel):
    """
    The standard product comparison table.
    """ # noqa: E501
    product_columns: Optional[Annotated[List[StandardComparisonProductBlock], Field(min_length=0, max_length=6)]] = Field(default=None, alias="productColumns")
    metric_row_labels: Optional[Annotated[List[PlainTextItem], Field(min_length=0, max_length=10)]] = Field(default=None, alias="metricRowLabels")
    __properties: ClassVar[List[str]] = ["productColumns", "metricRowLabels"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardComparisonTableModule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in product_columns (list)
        _items = []
        if self.product_columns:
            for _item_product_columns in self.product_columns:
                if _item_product_columns:
                    _items.append(_item_product_columns.to_dict())
            _dict['productColumns'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in metric_row_labels (list)
        _items = []
        if self.metric_row_labels:
            for _item_metric_row_labels in self.metric_row_labels:
                if _item_metric_row_labels:
                    _items.append(_item_metric_row_labels.to_dict())
            _dict['metricRowLabels'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardComparisonTableModule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "productColumns": [StandardComparisonProductBlock.from_dict(_item) for _item in obj["productColumns"]] if obj.get("productColumns") is not None else None,
            "metricRowLabels": [PlainTextItem.from_dict(_item) for _item in obj["metricRowLabels"]] if obj.get("metricRowLabels") is not None else None
        })
        return _obj


