# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_image_caption_block import StandardImageCaptionBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_image_text_block import StandardImageTextBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_text_block import StandardTextBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_text_list_block import StandardTextListBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.text_component import TextComponent
from typing import Optional, Set
from typing_extensions import Self

class StandardImageSidebarModule(BaseModel):
    """
    Two images, two paragraphs, and two bulleted lists. One image is smaller and displayed in the sidebar.
    """ # noqa: E501
    headline: Optional[TextComponent] = None
    image_caption_block: Optional[StandardImageCaptionBlock] = Field(default=None, alias="imageCaptionBlock")
    description_text_block: Optional[StandardTextBlock] = Field(default=None, alias="descriptionTextBlock")
    description_list_block: Optional[StandardTextListBlock] = Field(default=None, alias="descriptionListBlock")
    sidebar_image_text_block: Optional[StandardImageTextBlock] = Field(default=None, alias="sidebarImageTextBlock")
    sidebar_list_block: Optional[StandardTextListBlock] = Field(default=None, alias="sidebarListBlock")
    __properties: ClassVar[List[str]] = ["headline", "imageCaptionBlock", "descriptionTextBlock", "descriptionListBlock", "sidebarImageTextBlock", "sidebarListBlock"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardImageSidebarModule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of headline
        if self.headline:
            _dict['headline'] = self.headline.to_dict()
        # override the default output from pydantic by calling `to_dict()` of image_caption_block
        if self.image_caption_block:
            _dict['imageCaptionBlock'] = self.image_caption_block.to_dict()
        # override the default output from pydantic by calling `to_dict()` of description_text_block
        if self.description_text_block:
            _dict['descriptionTextBlock'] = self.description_text_block.to_dict()
        # override the default output from pydantic by calling `to_dict()` of description_list_block
        if self.description_list_block:
            _dict['descriptionListBlock'] = self.description_list_block.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sidebar_image_text_block
        if self.sidebar_image_text_block:
            _dict['sidebarImageTextBlock'] = self.sidebar_image_text_block.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sidebar_list_block
        if self.sidebar_list_block:
            _dict['sidebarListBlock'] = self.sidebar_list_block.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardImageSidebarModule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "headline": TextComponent.from_dict(obj["headline"]) if obj.get("headline") is not None else None,
            "imageCaptionBlock": StandardImageCaptionBlock.from_dict(obj["imageCaptionBlock"]) if obj.get("imageCaptionBlock") is not None else None,
            "descriptionTextBlock": StandardTextBlock.from_dict(obj["descriptionTextBlock"]) if obj.get("descriptionTextBlock") is not None else None,
            "descriptionListBlock": StandardTextListBlock.from_dict(obj["descriptionListBlock"]) if obj.get("descriptionListBlock") is not None else None,
            "sidebarImageTextBlock": StandardImageTextBlock.from_dict(obj["sidebarImageTextBlock"]) if obj.get("sidebarImageTextBlock") is not None else None,
            "sidebarListBlock": StandardTextListBlock.from_dict(obj["sidebarListBlock"]) if obj.get("sidebarListBlock") is not None else None
        })
        return _obj


