# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.aplusContent_2020_11_01.models.image_component import ImageComponent
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_header_text_list_block import StandardHeaderTextListBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_text_block import StandardTextBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.text_component import TextComponent
from typing import Optional, Set
from typing_extensions import Self

class StandardSingleImageHighlightsModule(BaseModel):
    """
    A standard image with several paragraphs and a bulleted list.
    """ # noqa: E501
    image: Optional[ImageComponent] = None
    headline: Optional[TextComponent] = None
    text_block1: Optional[StandardTextBlock] = Field(default=None, alias="textBlock1")
    text_block2: Optional[StandardTextBlock] = Field(default=None, alias="textBlock2")
    text_block3: Optional[StandardTextBlock] = Field(default=None, alias="textBlock3")
    bulleted_list_block: Optional[StandardHeaderTextListBlock] = Field(default=None, alias="bulletedListBlock")
    __properties: ClassVar[List[str]] = ["image", "headline", "textBlock1", "textBlock2", "textBlock3", "bulletedListBlock"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardSingleImageHighlightsModule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of image
        if self.image:
            _dict['image'] = self.image.to_dict()
        # override the default output from pydantic by calling `to_dict()` of headline
        if self.headline:
            _dict['headline'] = self.headline.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_block1
        if self.text_block1:
            _dict['textBlock1'] = self.text_block1.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_block2
        if self.text_block2:
            _dict['textBlock2'] = self.text_block2.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_block3
        if self.text_block3:
            _dict['textBlock3'] = self.text_block3.to_dict()
        # override the default output from pydantic by calling `to_dict()` of bulleted_list_block
        if self.bulleted_list_block:
            _dict['bulletedListBlock'] = self.bulleted_list_block.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardSingleImageHighlightsModule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "image": ImageComponent.from_dict(obj["image"]) if obj.get("image") is not None else None,
            "headline": TextComponent.from_dict(obj["headline"]) if obj.get("headline") is not None else None,
            "textBlock1": StandardTextBlock.from_dict(obj["textBlock1"]) if obj.get("textBlock1") is not None else None,
            "textBlock2": StandardTextBlock.from_dict(obj["textBlock2"]) if obj.get("textBlock2") is not None else None,
            "textBlock3": StandardTextBlock.from_dict(obj["textBlock3"]) if obj.get("textBlock3") is not None else None,
            "bulletedListBlock": StandardHeaderTextListBlock.from_dict(obj["bulletedListBlock"]) if obj.get("bulletedListBlock") is not None else None
        })
        return _obj


