# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_text_pair_block import StandardTextPairBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.text_component import TextComponent
from typing import Optional, Set
from typing_extensions import Self

class StandardTechSpecsModule(BaseModel):
    """
    The standard table of technical feature names and definitions.
    """ # noqa: E501
    headline: Optional[TextComponent] = None
    specification_list: Annotated[List[StandardTextPairBlock], Field(min_length=4, max_length=16)] = Field(description="The specification list.", alias="specificationList")
    table_count: Optional[Annotated[int, Field(le=2, strict=True, ge=1)]] = Field(default=None, description="The number of tables to present. Features are evenly divided between the tables.", alias="tableCount")
    __properties: ClassVar[List[str]] = ["headline", "specificationList", "tableCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardTechSpecsModule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of headline
        if self.headline:
            _dict['headline'] = self.headline.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in specification_list (list)
        _items = []
        if self.specification_list:
            for _item_specification_list in self.specification_list:
                if _item_specification_list:
                    _items.append(_item_specification_list.to_dict())
            _dict['specificationList'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardTechSpecsModule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "headline": TextComponent.from_dict(obj["headline"]) if obj.get("headline") is not None else None,
            "specificationList": [StandardTextPairBlock.from_dict(_item) for _item in obj["specificationList"]] if obj.get("specificationList") is not None else None,
            "tableCount": obj.get("tableCount")
        })
        return _obj


