# coding: utf-8

"""
    Selling Partner API for A+ Content Management

    With the A+ Content API, you can build applications that help selling partners add rich marketing content to their Amazon product detail pages. A+ content helps selling partners share their brand and product story, which helps buyers make informed purchasing decisions. Selling partners assemble content by choosing from content modules and adding images and text.

    The version of the OpenAPI document: 2020-11-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.aplusContent_2020_11_01.models.standard_image_text_block import StandardImageTextBlock
from py_sp_api.generated.aplusContent_2020_11_01.models.text_component import TextComponent
from typing import Optional, Set
from typing_extensions import Self

class StandardThreeImageTextModule(BaseModel):
    """
    Three standard images with text, presented across a single row.
    """ # noqa: E501
    headline: Optional[TextComponent] = None
    block1: Optional[StandardImageTextBlock] = None
    block2: Optional[StandardImageTextBlock] = None
    block3: Optional[StandardImageTextBlock] = None
    __properties: ClassVar[List[str]] = ["headline", "block1", "block2", "block3"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardThreeImageTextModule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of headline
        if self.headline:
            _dict['headline'] = self.headline.to_dict()
        # override the default output from pydantic by calling `to_dict()` of block1
        if self.block1:
            _dict['block1'] = self.block1.to_dict()
        # override the default output from pydantic by calling `to_dict()` of block2
        if self.block2:
            _dict['block2'] = self.block2.to_dict()
        # override the default output from pydantic by calling `to_dict()` of block3
        if self.block3:
            _dict['block3'] = self.block3.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardThreeImageTextModule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "headline": TextComponent.from_dict(obj["headline"]) if obj.get("headline") is not None else None,
            "block1": StandardImageTextBlock.from_dict(obj["block1"]) if obj.get("block1") is not None else None,
            "block2": StandardImageTextBlock.from_dict(obj["block2"]) if obj.get("block2") is not None else None,
            "block3": StandardImageTextBlock.from_dict(obj["block3"]) if obj.get("block3") is not None else None
        })
        return _obj


