# coding: utf-8

"""
    Selling Partner API for FBA Inventory

    The Selling Partner API for FBA Inventory lets you programmatically retrieve information about inventory in Amazon's fulfillment network.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fbaInventory.models.researching_quantity_entry import ResearchingQuantityEntry
from typing import Optional, Set
from typing_extensions import Self

class ResearchingQuantity(BaseModel):
    """
    The number of misplaced or warehouse damaged units that are actively being confirmed at our fulfillment centers.
    """ # noqa: E501
    total_researching_quantity: Optional[StrictInt] = Field(default=None, description="The total number of units currently being researched in Amazon's fulfillment network.", alias="totalResearchingQuantity")
    researching_quantity_breakdown: Optional[List[ResearchingQuantityEntry]] = Field(default=None, description="A list of quantity details for items currently being researched.", alias="researchingQuantityBreakdown")
    __properties: ClassVar[List[str]] = ["totalResearchingQuantity", "researchingQuantityBreakdown"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ResearchingQuantity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in researching_quantity_breakdown (list)
        _items = []
        if self.researching_quantity_breakdown:
            for _item_researching_quantity_breakdown in self.researching_quantity_breakdown:
                if _item_researching_quantity_breakdown:
                    _items.append(_item_researching_quantity_breakdown.to_dict())
            _dict['researchingQuantityBreakdown'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ResearchingQuantity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalResearchingQuantity": obj.get("totalResearchingQuantity"),
            "researchingQuantityBreakdown": [ResearchingQuantityEntry.from_dict(_item) for _item in obj["researchingQuantityBreakdown"]] if obj.get("researchingQuantityBreakdown") is not None else None
        })
        return _obj


