# coding: utf-8

"""
    Selling Partner API for FBA Inventory

    The Selling Partner API for FBA Inventory lets you programmatically retrieve information about inventory in Amazon's fulfillment network.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ReservedQuantity(BaseModel):
    """
    The quantity of reserved inventory.
    """ # noqa: E501
    total_reserved_quantity: Optional[StrictInt] = Field(default=None, description="The total number of units in Amazon's fulfillment network that are currently being picked, packed, and shipped; or are sidelined for measurement, sampling, or other internal processes.", alias="totalReservedQuantity")
    pending_customer_order_quantity: Optional[StrictInt] = Field(default=None, description="The number of units reserved for customer orders.", alias="pendingCustomerOrderQuantity")
    pending_transshipment_quantity: Optional[StrictInt] = Field(default=None, description="The number of units being transferred from one fulfillment center to another.", alias="pendingTransshipmentQuantity")
    fc_processing_quantity: Optional[StrictInt] = Field(default=None, description="The number of units that have been sidelined at the fulfillment center for additional processing.", alias="fcProcessingQuantity")
    __properties: ClassVar[List[str]] = ["totalReservedQuantity", "pendingCustomerOrderQuantity", "pendingTransshipmentQuantity", "fcProcessingQuantity"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReservedQuantity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReservedQuantity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalReservedQuantity": obj.get("totalReservedQuantity"),
            "pendingCustomerOrderQuantity": obj.get("pendingCustomerOrderQuantity"),
            "pendingTransshipmentQuantity": obj.get("pendingTransshipmentQuantity"),
            "fcProcessingQuantity": obj.get("fcProcessingQuantity")
        })
        return _obj


