# coding: utf-8

"""
    Selling Partner API for Finances

    The Selling Partner API for Finances helps you obtain financial information relevant to a seller's business. You can obtain financial events for a given order, financial event group, or date range without having to wait until a statement period closes. You can also obtain financial event groups for a given date range.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.financesV0.models.currency import Currency
from typing import Optional, Set
from typing_extensions import Self

class FailedAdhocDisbursementEvent(BaseModel):
    """
    Failed ad hoc disbursement event list.
    """ # noqa: E501
    funds_transfers_type: Optional[StrictStr] = Field(default=None, description="The type of fund transfer.   Example \"Refund\"", alias="FundsTransfersType")
    transfer_id: Optional[StrictStr] = Field(default=None, description="The transfer identifier.", alias="TransferId")
    disbursement_id: Optional[StrictStr] = Field(default=None, description="The disbursement identifier.", alias="DisbursementId")
    payment_disbursement_type: Optional[StrictStr] = Field(default=None, description="The type of payment for disbursement.   Example `CREDIT_CARD`", alias="PaymentDisbursementType")
    status: Optional[StrictStr] = Field(default=None, description="The status of the failed `AdhocDisbursement`.   Example `HARD_DECLINED`", alias="Status")
    transfer_amount: Optional[Currency] = Field(default=None, alias="TransferAmount")
    posted_date: Optional[datetime] = Field(default=None, description="Fields with a schema type of date are in ISO 8601 date time format (for example GroupBeginDate).", alias="PostedDate")
    __properties: ClassVar[List[str]] = ["FundsTransfersType", "TransferId", "DisbursementId", "PaymentDisbursementType", "Status", "TransferAmount", "PostedDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FailedAdhocDisbursementEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of transfer_amount
        if self.transfer_amount:
            _dict['TransferAmount'] = self.transfer_amount.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FailedAdhocDisbursementEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "FundsTransfersType": obj.get("FundsTransfersType"),
            "TransferId": obj.get("TransferId"),
            "DisbursementId": obj.get("DisbursementId"),
            "PaymentDisbursementType": obj.get("PaymentDisbursementType"),
            "Status": obj.get("Status"),
            "TransferAmount": Currency.from_dict(obj["TransferAmount"]) if obj.get("TransferAmount") is not None else None,
            "PostedDate": obj.get("PostedDate")
        })
        return _obj


