# coding: utf-8

"""
    The Selling Partner API for Finances

    The Selling Partner API for Finances provides financial information relevant to a seller's business. You can obtain financial events for a given order or date range without having to wait until a statement period closes.

    The version of the OpenAPI document: 2024-06-19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.finances_2024_06_19.models.breakdown import Breakdown
from py_sp_api.generated.finances_2024_06_19.models.context import Context
from py_sp_api.generated.finances_2024_06_19.models.currency import Currency
from py_sp_api.generated.finances_2024_06_19.models.item_related_identifier import ItemRelatedIdentifier
from typing import Optional, Set
from typing_extensions import Self

class Item(BaseModel):
    """
    Additional information about the items in a transaction.
    """ # noqa: E501
    description: Optional[StrictStr] = Field(default=None, description="A description of the items in a transaction.")
    related_identifiers: Optional[List[ItemRelatedIdentifier]] = Field(default=None, description="Related business identifiers of the item in the transaction.", alias="relatedIdentifiers")
    total_amount: Optional[Currency] = Field(default=None, alias="totalAmount")
    breakdowns: Optional[List[Breakdown]] = Field(default=None, description="A list of breakdowns that provide details on how the total amount is calculated for the transaction.")
    contexts: Optional[List[Context]] = Field(default=None, description="A list of additional information about the item.")
    __properties: ClassVar[List[str]] = ["description", "relatedIdentifiers", "totalAmount", "breakdowns", "contexts"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Item from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in related_identifiers (list)
        _items = []
        if self.related_identifiers:
            for _item_related_identifiers in self.related_identifiers:
                if _item_related_identifiers:
                    _items.append(_item_related_identifiers.to_dict())
            _dict['relatedIdentifiers'] = _items
        # override the default output from pydantic by calling `to_dict()` of total_amount
        if self.total_amount:
            _dict['totalAmount'] = self.total_amount.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in breakdowns (list)
        _items = []
        if self.breakdowns:
            for _item_breakdowns in self.breakdowns:
                if _item_breakdowns:
                    _items.append(_item_breakdowns.to_dict())
            _dict['breakdowns'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in contexts (list)
        _items = []
        if self.contexts:
            for _item_contexts in self.contexts:
                if _item_contexts:
                    _items.append(_item_contexts.to_dict())
            _dict['contexts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Item from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "relatedIdentifiers": [ItemRelatedIdentifier.from_dict(_item) for _item in obj["relatedIdentifiers"]] if obj.get("relatedIdentifiers") is not None else None,
            "totalAmount": Currency.from_dict(obj["totalAmount"]) if obj.get("totalAmount") is not None else None,
            "breakdowns": [Breakdown.from_dict(_item) for _item in obj["breakdowns"]] if obj.get("breakdowns") is not None else None,
            "contexts": [Context.from_dict(_item) for _item in obj["contexts"]] if obj.get("contexts") is not None else None
        })
        return _obj


