# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Address(BaseModel):
    """
    Specific details to identify a place.
    """ # noqa: E501
    name: Annotated[str, Field(strict=True, max_length=50)] = Field(description="Name of the individual or business.", alias="Name")
    address_line1: Annotated[str, Field(strict=True, max_length=180)] = Field(description="The street address information.", alias="AddressLine1")
    address_line2: Optional[Annotated[str, Field(strict=True, max_length=60)]] = Field(default=None, description="Additional street address information, if required.", alias="AddressLine2")
    district_or_county: Optional[Annotated[str, Field(strict=True, max_length=25)]] = Field(default=None, description="The district or county.", alias="DistrictOrCounty")
    city: Annotated[str, Field(strict=True, max_length=30)] = Field(description="The city.", alias="City")
    state_or_province_code: StrictStr = Field(description="The state or province code.  If state or province codes are used in your marketplace, it is recommended that you include one with your request. This helps Amazon to select the most appropriate Amazon fulfillment center for your inbound shipment plan.", alias="StateOrProvinceCode")
    country_code: StrictStr = Field(description="The country code in two-character ISO 3166-1 alpha-2 format.", alias="CountryCode")
    postal_code: Annotated[str, Field(strict=True, max_length=30)] = Field(description="The postal code.  If postal codes are used in your marketplace, we recommended that you include one with your request. This helps Amazon select the most appropriate Amazon fulfillment center for the inbound shipment plan.", alias="PostalCode")
    __properties: ClassVar[List[str]] = ["Name", "AddressLine1", "AddressLine2", "DistrictOrCounty", "City", "StateOrProvinceCode", "CountryCode", "PostalCode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Address from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Address from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Name": obj.get("Name"),
            "AddressLine1": obj.get("AddressLine1"),
            "AddressLine2": obj.get("AddressLine2"),
            "DistrictOrCounty": obj.get("DistrictOrCounty"),
            "City": obj.get("City"),
            "StateOrProvinceCode": obj.get("StateOrProvinceCode"),
            "CountryCode": obj.get("CountryCode"),
            "PostalCode": obj.get("PostalCode")
        })
        return _obj


