# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentInboundV0.models.barcode_instruction import BarcodeInstruction
from py_sp_api.generated.fulfillmentInboundV0.models.prep_guidance import PrepGuidance
from py_sp_api.generated.fulfillmentInboundV0.models.prep_instruction import PrepInstruction
from typing import Optional, Set
from typing_extensions import Self

class ASINPrepInstructions(BaseModel):
    """
    Item preparation instructions to help with item sourcing decisions.
    """ # noqa: E501
    asin: Optional[StrictStr] = Field(default=None, description="The Amazon Standard Identification Number (ASIN) of the item.", alias="ASIN")
    barcode_instruction: Optional[BarcodeInstruction] = Field(default=None, alias="BarcodeInstruction")
    prep_guidance: Optional[PrepGuidance] = Field(default=None, alias="PrepGuidance")
    prep_instruction_list: Optional[List[PrepInstruction]] = Field(default=None, description="A list of preparation instructions to help with item sourcing decisions.", alias="PrepInstructionList")
    __properties: ClassVar[List[str]] = ["ASIN", "BarcodeInstruction", "PrepGuidance", "PrepInstructionList"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ASINPrepInstructions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ASINPrepInstructions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ASIN": obj.get("ASIN"),
            "BarcodeInstruction": obj.get("BarcodeInstruction"),
            "PrepGuidance": obj.get("PrepGuidance"),
            "PrepInstructionList": obj.get("PrepInstructionList")
        })
        return _obj


