# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentInboundV0.models.inbound_shipment_info import InboundShipmentInfo
from typing import Optional, Set
from typing_extensions import Self

class GetShipmentsResult(BaseModel):
    """
    Result for the get shipments operation
    """ # noqa: E501
    shipment_data: Optional[List[InboundShipmentInfo]] = Field(default=None, description="A list of inbound shipment information.", alias="ShipmentData")
    next_token: Optional[StrictStr] = Field(default=None, description="When present and not empty, pass this string token in the next request to return the next response page.", alias="NextToken")
    __properties: ClassVar[List[str]] = ["ShipmentData", "NextToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetShipmentsResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in shipment_data (list)
        _items = []
        if self.shipment_data:
            for _item_shipment_data in self.shipment_data:
                if _item_shipment_data:
                    _items.append(_item_shipment_data.to_dict())
            _dict['ShipmentData'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetShipmentsResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ShipmentData": [InboundShipmentInfo.from_dict(_item) for _item in obj["ShipmentData"]] if obj.get("ShipmentData") is not None else None,
            "NextToken": obj.get("NextToken")
        })
        return _obj


