# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentInboundV0.models.address import Address
from py_sp_api.generated.fulfillmentInboundV0.models.box_contents_fee_details import BoxContentsFeeDetails
from py_sp_api.generated.fulfillmentInboundV0.models.box_contents_source import BoxContentsSource
from py_sp_api.generated.fulfillmentInboundV0.models.label_prep_type import LabelPrepType
from py_sp_api.generated.fulfillmentInboundV0.models.shipment_status import ShipmentStatus
from typing import Optional, Set
from typing_extensions import Self

class InboundShipmentInfo(BaseModel):
    """
    Information about the seller's inbound shipments. Returned by the listInboundShipments operation.
    """ # noqa: E501
    shipment_id: Optional[StrictStr] = Field(default=None, description="The shipment identifier submitted in the request.", alias="ShipmentId")
    shipment_name: Optional[StrictStr] = Field(default=None, description="The name for the inbound shipment.", alias="ShipmentName")
    ship_from_address: Address = Field(alias="ShipFromAddress")
    destination_fulfillment_center_id: Optional[StrictStr] = Field(default=None, description="An Amazon fulfillment center identifier created by Amazon.", alias="DestinationFulfillmentCenterId")
    shipment_status: Optional[ShipmentStatus] = Field(default=None, alias="ShipmentStatus")
    label_prep_type: Optional[LabelPrepType] = Field(default=None, alias="LabelPrepType")
    are_cases_required: StrictBool = Field(description="Indicates whether or not an inbound shipment contains case-packed boxes. When AreCasesRequired = true for an inbound shipment, all items in the inbound shipment must be case packed.", alias="AreCasesRequired")
    confirmed_need_by_date: Optional[date] = Field(default=None, description="Type containing date in string format", alias="ConfirmedNeedByDate")
    box_contents_source: Optional[BoxContentsSource] = Field(default=None, alias="BoxContentsSource")
    estimated_box_contents_fee: Optional[BoxContentsFeeDetails] = Field(default=None, alias="EstimatedBoxContentsFee")
    __properties: ClassVar[List[str]] = ["ShipmentId", "ShipmentName", "ShipFromAddress", "DestinationFulfillmentCenterId", "ShipmentStatus", "LabelPrepType", "AreCasesRequired", "ConfirmedNeedByDate", "BoxContentsSource", "EstimatedBoxContentsFee"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InboundShipmentInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ship_from_address
        if self.ship_from_address:
            _dict['ShipFromAddress'] = self.ship_from_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of estimated_box_contents_fee
        if self.estimated_box_contents_fee:
            _dict['EstimatedBoxContentsFee'] = self.estimated_box_contents_fee.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InboundShipmentInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ShipmentId": obj.get("ShipmentId"),
            "ShipmentName": obj.get("ShipmentName"),
            "ShipFromAddress": Address.from_dict(obj["ShipFromAddress"]) if obj.get("ShipFromAddress") is not None else None,
            "DestinationFulfillmentCenterId": obj.get("DestinationFulfillmentCenterId"),
            "ShipmentStatus": obj.get("ShipmentStatus"),
            "LabelPrepType": obj.get("LabelPrepType"),
            "AreCasesRequired": obj.get("AreCasesRequired"),
            "ConfirmedNeedByDate": obj.get("ConfirmedNeedByDate"),
            "BoxContentsSource": obj.get("BoxContentsSource"),
            "EstimatedBoxContentsFee": BoxContentsFeeDetails.from_dict(obj["EstimatedBoxContentsFee"]) if obj.get("EstimatedBoxContentsFee") is not None else None
        })
        return _obj


