# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentInboundV0.models.partnered_estimate import PartneredEstimate
from py_sp_api.generated.fulfillmentInboundV0.models.partnered_small_parcel_package_output import PartneredSmallParcelPackageOutput
from typing import Optional, Set
from typing_extensions import Self

class PartneredSmallParcelDataOutput(BaseModel):
    """
    Information returned by Amazon about a Small Parcel shipment by an Amazon-partnered carrier.
    """ # noqa: E501
    package_list: List[PartneredSmallParcelPackageOutput] = Field(description="A list of packages, including shipping information from the Amazon-partnered carrier.", alias="PackageList")
    partnered_estimate: Optional[PartneredEstimate] = Field(default=None, alias="PartneredEstimate")
    __properties: ClassVar[List[str]] = ["PackageList", "PartneredEstimate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PartneredSmallParcelDataOutput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in package_list (list)
        _items = []
        if self.package_list:
            for _item_package_list in self.package_list:
                if _item_package_list:
                    _items.append(_item_package_list.to_dict())
            _dict['PackageList'] = _items
        # override the default output from pydantic by calling `to_dict()` of partnered_estimate
        if self.partnered_estimate:
            _dict['PartneredEstimate'] = self.partnered_estimate.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PartneredSmallParcelDataOutput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "PackageList": [PartneredSmallParcelPackageOutput.from_dict(_item) for _item in obj["PackageList"]] if obj.get("PackageList") is not None else None,
            "PartneredEstimate": PartneredEstimate.from_dict(obj["PartneredEstimate"]) if obj.get("PartneredEstimate") is not None else None
        })
        return _obj


