# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from py_sp_api.generated.fulfillmentInboundV0.models.transport_detail_output import TransportDetailOutput
from py_sp_api.generated.fulfillmentInboundV0.models.transport_header import TransportHeader
from py_sp_api.generated.fulfillmentInboundV0.models.transport_result import TransportResult
from typing import Optional, Set
from typing_extensions import Self

class TransportContent(BaseModel):
    """
    Inbound shipment information, including carrier details, shipment status, and the workflow status for a request for shipment with an Amazon-partnered carrier.
    """ # noqa: E501
    transport_header: TransportHeader = Field(alias="TransportHeader")
    transport_details: TransportDetailOutput = Field(alias="TransportDetails")
    transport_result: TransportResult = Field(alias="TransportResult")
    __properties: ClassVar[List[str]] = ["TransportHeader", "TransportDetails", "TransportResult"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransportContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of transport_header
        if self.transport_header:
            _dict['TransportHeader'] = self.transport_header.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transport_details
        if self.transport_details:
            _dict['TransportDetails'] = self.transport_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transport_result
        if self.transport_result:
            _dict['TransportResult'] = self.transport_result.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransportContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "TransportHeader": TransportHeader.from_dict(obj["TransportHeader"]) if obj.get("TransportHeader") is not None else None,
            "TransportDetails": TransportDetailOutput.from_dict(obj["TransportDetails"]) if obj.get("TransportDetails") is not None else None,
            "TransportResult": TransportResult.from_dict(obj["TransportResult"]) if obj.get("TransportResult") is not None else None
        })
        return _obj


