# coding: utf-8

"""
    Selling Partner API for Fulfillment Inbound

    The Selling Partner API for Fulfillment Inbound lets you create applications that create and update inbound shipments of inventory to Amazon's fulfillment network.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentInboundV0.models.non_partnered_ltl_data_output import NonPartneredLtlDataOutput
from py_sp_api.generated.fulfillmentInboundV0.models.non_partnered_small_parcel_data_output import NonPartneredSmallParcelDataOutput
from py_sp_api.generated.fulfillmentInboundV0.models.partnered_ltl_data_output import PartneredLtlDataOutput
from py_sp_api.generated.fulfillmentInboundV0.models.partnered_small_parcel_data_output import PartneredSmallParcelDataOutput
from typing import Optional, Set
from typing_extensions import Self

class TransportDetailOutput(BaseModel):
    """
    Inbound shipment information, including carrier details and shipment status.
    """ # noqa: E501
    partnered_small_parcel_data: Optional[PartneredSmallParcelDataOutput] = Field(default=None, alias="PartneredSmallParcelData")
    non_partnered_small_parcel_data: Optional[NonPartneredSmallParcelDataOutput] = Field(default=None, alias="NonPartneredSmallParcelData")
    partnered_ltl_data: Optional[PartneredLtlDataOutput] = Field(default=None, alias="PartneredLtlData")
    non_partnered_ltl_data: Optional[NonPartneredLtlDataOutput] = Field(default=None, alias="NonPartneredLtlData")
    __properties: ClassVar[List[str]] = ["PartneredSmallParcelData", "NonPartneredSmallParcelData", "PartneredLtlData", "NonPartneredLtlData"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransportDetailOutput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of partnered_small_parcel_data
        if self.partnered_small_parcel_data:
            _dict['PartneredSmallParcelData'] = self.partnered_small_parcel_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of non_partnered_small_parcel_data
        if self.non_partnered_small_parcel_data:
            _dict['NonPartneredSmallParcelData'] = self.non_partnered_small_parcel_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of partnered_ltl_data
        if self.partnered_ltl_data:
            _dict['PartneredLtlData'] = self.partnered_ltl_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of non_partnered_ltl_data
        if self.non_partnered_ltl_data:
            _dict['NonPartneredLtlData'] = self.non_partnered_ltl_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransportDetailOutput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "PartneredSmallParcelData": PartneredSmallParcelDataOutput.from_dict(obj["PartneredSmallParcelData"]) if obj.get("PartneredSmallParcelData") is not None else None,
            "NonPartneredSmallParcelData": NonPartneredSmallParcelDataOutput.from_dict(obj["NonPartneredSmallParcelData"]) if obj.get("NonPartneredSmallParcelData") is not None else None,
            "PartneredLtlData": PartneredLtlDataOutput.from_dict(obj["PartneredLtlData"]) if obj.get("PartneredLtlData") is not None else None,
            "NonPartneredLtlData": NonPartneredLtlDataOutput.from_dict(obj["NonPartneredLtlData"]) if obj.get("NonPartneredLtlData") is not None else None
        })
        return _obj


