# coding: utf-8

"""
    Fulfillment Inbound v2024-03-20

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Address(BaseModel):
    """
    Specific details to identify a place.
    """ # noqa: E501
    address_line1: Annotated[str, Field(min_length=1, strict=True, max_length=180)] = Field(description="Street address information.", alias="addressLine1")
    address_line2: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=60)]] = Field(default=None, description="Additional street address information.", alias="addressLine2")
    city: Annotated[str, Field(min_length=1, strict=True, max_length=30)] = Field(description="The city.")
    company_name: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=50)]] = Field(default=None, description="The name of the business.", alias="companyName")
    country_code: Annotated[str, Field(min_length=2, strict=True, max_length=2)] = Field(description="The country code in two-character ISO 3166-1 alpha-2 format.", alias="countryCode")
    email: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=1024)]] = Field(default=None, description="The email address.")
    name: Annotated[str, Field(min_length=1, strict=True, max_length=50)] = Field(description="The name of the individual who is the primary contact.")
    phone_number: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=20)]] = Field(default=None, description="The phone number.", alias="phoneNumber")
    postal_code: Annotated[str, Field(min_length=1, strict=True, max_length=32)] = Field(description="The postal code.", alias="postalCode")
    state_or_province_code: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="The state or province code.", alias="stateOrProvinceCode")
    __properties: ClassVar[List[str]] = ["addressLine1", "addressLine2", "city", "companyName", "countryCode", "email", "name", "phoneNumber", "postalCode", "stateOrProvinceCode"]

    @field_validator('country_code')
    def country_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[A-Z]{2}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z]{2}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Address from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Address from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "city": obj.get("city"),
            "companyName": obj.get("companyName"),
            "countryCode": obj.get("countryCode"),
            "email": obj.get("email"),
            "name": obj.get("name"),
            "phoneNumber": obj.get("phoneNumber"),
            "postalCode": obj.get("postalCode"),
            "stateOrProvinceCode": obj.get("stateOrProvinceCode")
        })
        return _obj


