# coding: utf-8

"""
    Fulfillment Inbound v2024-03-20

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from py_sp_api.generated.fulfillmentInbound_2024_03_20.models.requested_updates import RequestedUpdates
from py_sp_api.generated.fulfillmentInbound_2024_03_20.models.transportation_option import TransportationOption
from typing import Optional, Set
from typing_extensions import Self

class ContentUpdatePreview(BaseModel):
    """
    Preview of the changes that will be applied to the shipment.
    """ # noqa: E501
    content_update_preview_id: Annotated[str, Field(min_length=38, strict=True, max_length=38)] = Field(description="Identifier of a content update preview.", alias="contentUpdatePreviewId")
    expiration: datetime = Field(description="The time at which the content update expires. In [ISO 8601](https://developer-docs.amazon.com/sp-api/docs/iso-8601) datetime format with pattern `yyyy-MM-ddTHH:mm:ss.sssZ`.")
    requested_updates: RequestedUpdates = Field(alias="requestedUpdates")
    transportation_option: TransportationOption = Field(alias="transportationOption")
    __properties: ClassVar[List[str]] = ["contentUpdatePreviewId", "expiration", "requestedUpdates", "transportationOption"]

    @field_validator('content_update_preview_id')
    def content_update_preview_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9-]*$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9-]*$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ContentUpdatePreview from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of requested_updates
        if self.requested_updates:
            _dict['requestedUpdates'] = self.requested_updates.to_dict()
        # override the default output from pydantic by calling `to_dict()` of transportation_option
        if self.transportation_option:
            _dict['transportationOption'] = self.transportation_option.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ContentUpdatePreview from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contentUpdatePreviewId": obj.get("contentUpdatePreviewId"),
            "expiration": obj.get("expiration"),
            "requestedUpdates": RequestedUpdates.from_dict(obj["requestedUpdates"]) if obj.get("requestedUpdates") is not None else None,
            "transportationOption": TransportationOption.from_dict(obj["transportationOption"]) if obj.get("transportationOption") is not None else None
        })
        return _obj


