# coding: utf-8

"""
    Fulfillment Inbound v2024-03-20

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class OwnerConstraint(str, Enum):
    """
    A constraint that can apply to an individual owner. If no constraint is specified, both `AMAZON` and `SELLER` are acceptable.
    """

    """
    allowed enum values
    """
    AMAZON_ONLY = 'AMAZON_ONLY'
    NONE_ONLY = 'NONE_ONLY'
    SELLER_ONLY = 'SELLER_ONLY'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OwnerConstraint from a JSON string"""
        return cls(json.loads(json_str))


