# coding: utf-8

"""
    Fulfillment Inbound v2024-03-20

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class PrepType(str, Enum):
    """
    Preparation instructions for shipping an item to Amazon's fulfillment network. For more information about preparing items for shipment to Amazon's fulfillment network, refer to [Seller Central Help for your marketplace](https://developer-docs.amazon.com/sp-api/docs/seller-central-urls).
    """

    """
    allowed enum values
    """
    ITEM_BLACK_SHRINKWRAP = 'ITEM_BLACK_SHRINKWRAP'
    ITEM_BLANKSTK = 'ITEM_BLANKSTK'
    ITEM_BOXING = 'ITEM_BOXING'
    ITEM_BUBBLEWRAP = 'ITEM_BUBBLEWRAP'
    ITEM_CAP_SEALING = 'ITEM_CAP_SEALING'
    ITEM_DEBUNDLE = 'ITEM_DEBUNDLE'
    ITEM_HANG_GARMENT = 'ITEM_HANG_GARMENT'
    ITEM_LABELING = 'ITEM_LABELING'
    ITEM_NO_PREP = 'ITEM_NO_PREP'
    ITEM_POLYBAGGING = 'ITEM_POLYBAGGING'
    ITEM_RMOVHANG = 'ITEM_RMOVHANG'
    ITEM_SETCREAT = 'ITEM_SETCREAT'
    ITEM_SETSTK = 'ITEM_SETSTK'
    ITEM_SIOC = 'ITEM_SIOC'
    ITEM_SUFFOSTK = 'ITEM_SUFFOSTK'
    ITEM_TAPING = 'ITEM_TAPING'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PrepType from a JSON string"""
        return cls(json.loads(json_str))


