# coding: utf-8

"""
    Fulfillment Inbound v2024-03-20

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ReasonComment(str, Enum):
    """
    Reason for cancelling or rescheduling a self-ship appointment.
    """

    """
    allowed enum values
    """
    APPOINTMENT_REQUESTED_BY_MISTAKE = 'APPOINTMENT_REQUESTED_BY_MISTAKE'
    VEHICLE_DELAY = 'VEHICLE_DELAY'
    SLOT_NOT_SUITABLE = 'SLOT_NOT_SUITABLE'
    OUTSIDE_CARRIER_BUSINESS_HOURS = 'OUTSIDE_CARRIER_BUSINESS_HOURS'
    UNFAVOURABLE_EXTERNAL_CONDITIONS = 'UNFAVOURABLE_EXTERNAL_CONDITIONS'
    PROCUREMENT_DELAY = 'PROCUREMENT_DELAY'
    SHIPPING_PLAN_CHANGED = 'SHIPPING_PLAN_CHANGED'
    INCREASED_QUANTITY = 'INCREASED_QUANTITY'
    OTHER = 'OTHER'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ReasonComment from a JSON string"""
        return cls(json.loads(json_str))


