# coding: utf-8

"""
    Fulfillment Inbound v2024-03-20

    The Selling Partner API for Fulfillment By Amazon (FBA) Inbound. The FBA Inbound API enables building inbound workflows to create, manage, and send shipments into Amazon's fulfillment network. The API has interoperability with the Send-to-Amazon user interface.

    The version of the OpenAPI document: 2024-03-20
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.fulfillmentInbound_2024_03_20.models.contact_information import ContactInformation
from py_sp_api.generated.fulfillmentInbound_2024_03_20.models.freight_information import FreightInformation
from py_sp_api.generated.fulfillmentInbound_2024_03_20.models.pallet_input import PalletInput
from py_sp_api.generated.fulfillmentInbound_2024_03_20.models.window_input import WindowInput
from typing import Optional, Set
from typing_extensions import Self

class ShipmentTransportationConfiguration(BaseModel):
    """
    Details needed to generate the transportation options.
    """ # noqa: E501
    contact_information: Optional[ContactInformation] = Field(default=None, alias="contactInformation")
    freight_information: Optional[FreightInformation] = Field(default=None, alias="freightInformation")
    pallets: Optional[List[PalletInput]] = Field(default=None, description="List of pallet configuration inputs.")
    ready_to_ship_window: WindowInput = Field(alias="readyToShipWindow")
    shipment_id: Annotated[str, Field(min_length=38, strict=True, max_length=38)] = Field(description="Identifier of a shipment. A shipment contains the boxes and units being inbounded.", alias="shipmentId")
    __properties: ClassVar[List[str]] = ["contactInformation", "freightInformation", "pallets", "readyToShipWindow", "shipmentId"]

    @field_validator('shipment_id')
    def shipment_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9-]*$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9-]*$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ShipmentTransportationConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of contact_information
        if self.contact_information:
            _dict['contactInformation'] = self.contact_information.to_dict()
        # override the default output from pydantic by calling `to_dict()` of freight_information
        if self.freight_information:
            _dict['freightInformation'] = self.freight_information.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in pallets (list)
        _items = []
        if self.pallets:
            for _item_pallets in self.pallets:
                if _item_pallets:
                    _items.append(_item_pallets.to_dict())
            _dict['pallets'] = _items
        # override the default output from pydantic by calling `to_dict()` of ready_to_ship_window
        if self.ready_to_ship_window:
            _dict['readyToShipWindow'] = self.ready_to_ship_window.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ShipmentTransportationConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contactInformation": ContactInformation.from_dict(obj["contactInformation"]) if obj.get("contactInformation") is not None else None,
            "freightInformation": FreightInformation.from_dict(obj["freightInformation"]) if obj.get("freightInformation") is not None else None,
            "pallets": [PalletInput.from_dict(_item) for _item in obj["pallets"]] if obj.get("pallets") is not None else None,
            "readyToShipWindow": WindowInput.from_dict(obj["readyToShipWindow"]) if obj.get("readyToShipWindow") is not None else None,
            "shipmentId": obj.get("shipmentId")
        })
        return _obj


