# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Address(BaseModel):
    """
    A physical address.
    """ # noqa: E501
    name: StrictStr = Field(description="The name of the person, business or institution at the address.")
    address_line1: StrictStr = Field(description="The first line of the address.", alias="addressLine1")
    address_line2: Optional[StrictStr] = Field(default=None, description="Additional address information, if required.", alias="addressLine2")
    address_line3: Optional[StrictStr] = Field(default=None, description="Additional address information, if required.", alias="addressLine3")
    city: Optional[StrictStr] = Field(default=None, description="The city where the person, business, or institution is located. This property is required in all countries except Japan. It should not be used in Japan.")
    district_or_county: Optional[StrictStr] = Field(default=None, description="The district or county where the person, business, or institution is located.", alias="districtOrCounty")
    state_or_region: StrictStr = Field(description="The state or region where the person, business or institution is located.", alias="stateOrRegion")
    postal_code: StrictStr = Field(description="The postal code of the address.", alias="postalCode")
    country_code: StrictStr = Field(description="The two digit country code. In ISO 3166-1 alpha-2 format.", alias="countryCode")
    phone: Optional[StrictStr] = Field(default=None, description="The phone number of the person, business, or institution located at the address.")
    __properties: ClassVar[List[str]] = ["name", "addressLine1", "addressLine2", "addressLine3", "city", "districtOrCounty", "stateOrRegion", "postalCode", "countryCode", "phone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Address from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Address from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "addressLine3": obj.get("addressLine3"),
            "city": obj.get("city"),
            "districtOrCounty": obj.get("districtOrCounty"),
            "stateOrRegion": obj.get("stateOrRegion"),
            "postalCode": obj.get("postalCode"),
            "countryCode": obj.get("countryCode"),
            "phone": obj.get("phone")
        })
        return _obj


