# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class CurrentStatus(str, Enum):
    """
    The current delivery status of the package.
    """

    """
    allowed enum values
    """
    IN_TRANSIT = 'IN_TRANSIT'
    DELIVERED = 'DELIVERED'
    RETURNING = 'RETURNING'
    RETURNED = 'RETURNED'
    UNDELIVERABLE = 'UNDELIVERABLE'
    DELAYED = 'DELAYED'
    AVAILABLE_FOR_PICKUP = 'AVAILABLE_FOR_PICKUP'
    CUSTOMER_ACTION = 'CUSTOMER_ACTION'
    UNKNOWN = 'UNKNOWN'
    OUT_FOR_DELIVERY = 'OUT_FOR_DELIVERY'
    DELIVERY_ATTEMPTED = 'DELIVERY_ATTEMPTED'
    PICKUP_SUCCESSFUL = 'PICKUP_SUCCESSFUL'
    PICKUP_CANCELLED = 'PICKUP_CANCELLED'
    PICKUP_ATTEMPTED = 'PICKUP_ATTEMPTED'
    PICKUP_SCHEDULED = 'PICKUP_SCHEDULED'
    RETURN_REQUEST_ACCEPTED = 'RETURN_REQUEST_ACCEPTED'
    REFUND_ISSUED = 'REFUND_ISSUED'
    RETURN_RECEIVED_IN_FC = 'RETURN_RECEIVED_IN_FC'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CurrentStatus from a JSON string"""
        return cls(json.loads(json_str))


