# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentOutbound_2020_07_01.models.delivery_document import DeliveryDocument
from py_sp_api.generated.fulfillmentOutbound_2020_07_01.models.drop_off_location import DropOffLocation
from typing import Optional, Set
from typing_extensions import Self

class DeliveryInformation(BaseModel):
    """
    The delivery information for the package. This information is available after the package is delivered.
    """ # noqa: E501
    delivery_document_list: Optional[List[DeliveryDocument]] = Field(default=None, description="A list of delivery documents for a package.", alias="deliveryDocumentList")
    drop_off_location: Optional[DropOffLocation] = Field(default=None, alias="dropOffLocation")
    __properties: ClassVar[List[str]] = ["deliveryDocumentList", "dropOffLocation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeliveryInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in delivery_document_list (list)
        _items = []
        if self.delivery_document_list:
            for _item_delivery_document_list in self.delivery_document_list:
                if _item_delivery_document_list:
                    _items.append(_item_delivery_document_list.to_dict())
            _dict['deliveryDocumentList'] = _items
        # override the default output from pydantic by calling `to_dict()` of drop_off_location
        if self.drop_off_location:
            _dict['dropOffLocation'] = self.drop_off_location.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeliveryInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "deliveryDocumentList": [DeliveryDocument.from_dict(_item) for _item in obj["deliveryDocumentList"]] if obj.get("deliveryDocumentList") is not None else None,
            "dropOffLocation": DropOffLocation.from_dict(obj["dropOffLocation"]) if obj.get("dropOffLocation") is not None else None
        })
        return _obj


