# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentOutbound_2020_07_01.models.fulfillment_preview_item import FulfillmentPreviewItem
from typing import Optional, Set
from typing_extensions import Self

class FulfillmentPreviewShipment(BaseModel):
    """
    Delivery and item information for a shipment in a fulfillment order preview.
    """ # noqa: E501
    earliest_ship_date: Optional[datetime] = Field(default=None, description="Date timestamp", alias="earliestShipDate")
    latest_ship_date: Optional[datetime] = Field(default=None, description="Date timestamp", alias="latestShipDate")
    earliest_arrival_date: Optional[datetime] = Field(default=None, description="Date timestamp", alias="earliestArrivalDate")
    latest_arrival_date: Optional[datetime] = Field(default=None, description="Date timestamp", alias="latestArrivalDate")
    shipping_notes: Optional[List[StrictStr]] = Field(default=None, description="Provides additional insight into the shipment timeline when exact delivery dates are not able to be precomputed.", alias="shippingNotes")
    fulfillment_preview_items: List[FulfillmentPreviewItem] = Field(description="An array of fulfillment preview item information.", alias="fulfillmentPreviewItems")
    __properties: ClassVar[List[str]] = ["earliestShipDate", "latestShipDate", "earliestArrivalDate", "latestArrivalDate", "shippingNotes", "fulfillmentPreviewItems"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FulfillmentPreviewShipment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in fulfillment_preview_items (list)
        _items = []
        if self.fulfillment_preview_items:
            for _item_fulfillment_preview_items in self.fulfillment_preview_items:
                if _item_fulfillment_preview_items:
                    _items.append(_item_fulfillment_preview_items.to_dict())
            _dict['fulfillmentPreviewItems'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FulfillmentPreviewShipment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "earliestShipDate": obj.get("earliestShipDate"),
            "latestShipDate": obj.get("latestShipDate"),
            "earliestArrivalDate": obj.get("earliestArrivalDate"),
            "latestArrivalDate": obj.get("latestArrivalDate"),
            "shippingNotes": obj.get("shippingNotes"),
            "fulfillmentPreviewItems": [FulfillmentPreviewItem.from_dict(_item) for _item in obj["fulfillmentPreviewItems"]] if obj.get("fulfillmentPreviewItems") is not None else None
        })
        return _obj


