# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.fulfillmentOutbound_2020_07_01.models.feature_sku import FeatureSku
from typing import Optional, Set
from typing_extensions import Self

class GetFeatureInventoryResult(BaseModel):
    """
    The payload for the `getEligibileInventory` operation.
    """ # noqa: E501
    marketplace_id: StrictStr = Field(description="The requested marketplace.", alias="marketplaceId")
    feature_name: StrictStr = Field(description="The name of the feature.", alias="featureName")
    next_token: Optional[StrictStr] = Field(default=None, description="When present and not empty, pass this string token in the next request to return the next response page.", alias="nextToken")
    feature_skus: Optional[List[FeatureSku]] = Field(default=None, description="An array of SKUs eligible for this feature and the quantity available.", alias="featureSkus")
    __properties: ClassVar[List[str]] = ["marketplaceId", "featureName", "nextToken", "featureSkus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetFeatureInventoryResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in feature_skus (list)
        _items = []
        if self.feature_skus:
            for _item_feature_skus in self.feature_skus:
                if _item_feature_skus:
                    _items.append(_item_feature_skus.to_dict())
            _dict['featureSkus'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetFeatureInventoryResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "marketplaceId": obj.get("marketplaceId"),
            "featureName": obj.get("featureName"),
            "nextToken": obj.get("nextToken"),
            "featureSkus": [FeatureSku.from_dict(_item) for _item in obj["featureSkus"]] if obj.get("featureSkus") is not None else None
        })
        return _obj


