# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from py_sp_api.generated.fulfillmentOutbound_2020_07_01.models.address import Address
from typing import Optional, Set
from typing_extensions import Self

class ReturnAuthorization(BaseModel):
    """
    Return authorization information for items accepted for return.
    """ # noqa: E501
    return_authorization_id: StrictStr = Field(description="An identifier for the return authorization. This identifier associates return items with the return authorization used to return them.", alias="returnAuthorizationId")
    fulfillment_center_id: StrictStr = Field(description="An identifier for the Amazon fulfillment center that the return items should be sent to.", alias="fulfillmentCenterId")
    return_to_address: Address = Field(alias="returnToAddress")
    amazon_rma_id: StrictStr = Field(description="The return merchandise authorization (RMA) that Amazon needs to process the return.", alias="amazonRmaId")
    rma_page_url: StrictStr = Field(description="A URL for a web page that contains the return authorization barcode and the mailing label. This does not include pre-paid shipping.", alias="rmaPageURL")
    __properties: ClassVar[List[str]] = ["returnAuthorizationId", "fulfillmentCenterId", "returnToAddress", "amazonRmaId", "rmaPageURL"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReturnAuthorization from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of return_to_address
        if self.return_to_address:
            _dict['returnToAddress'] = self.return_to_address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReturnAuthorization from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "returnAuthorizationId": obj.get("returnAuthorizationId"),
            "fulfillmentCenterId": obj.get("fulfillmentCenterId"),
            "returnToAddress": Address.from_dict(obj["returnToAddress"]) if obj.get("returnToAddress") is not None else None,
            "amazonRmaId": obj.get("amazonRmaId"),
            "rmaPageURL": obj.get("rmaPageURL")
        })
        return _obj


