# coding: utf-8

"""
    Selling Partner APIs for Fulfillment Outbound

    The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ShippingSpeedCategory(str, Enum):
    """
    The shipping method used for the fulfillment order. When this value is `ScheduledDelivery`, choose `Ship` for the `fulfillmentAction`. `Hold` is not a valid `fulfillmentAction` value when the `shippingSpeedCategory` value is `ScheduledDelivery`. Note: Shipping method service level agreements vary by marketplace. Sellers should refer to the [Seller Central](https://developer-docs.amazon.com/sp-api/docs/seller-central-urls) website in their marketplace for shipping method service level agreements and fulfillment fees.
    """

    """
    allowed enum values
    """
    STANDARD = 'Standard'
    EXPEDITED = 'Expedited'
    PRIORITY = 'Priority'
    SCHEDULEDDELIVERY = 'ScheduledDelivery'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ShippingSpeedCategory from a JSON string"""
        return cls(json.loads(json_str))


