# PatchOperation

Individual JSON Patch operation for an HTTP PATCH request.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**op** | **str** | Type of JSON Patch operation. Supported JSON Patch operations include add, replace, and delete. See &lt;https://tools.ietf.org/html/rfc6902&gt;. | 
**path** | **str** | JSON Pointer path of the element to patch. See &lt;https://tools.ietf.org/html/rfc6902&gt;. | 
**value** | **List[Dict[str, object]]** | JSON value to add, replace, or delete. | [optional] 

## Example

```python
from py_sp_api.generated.listingsItems_2020_09_01.models.patch_operation import PatchOperation

# TODO update the JSON string below
json = "{}"
# create an instance of PatchOperation from a JSON string
patch_operation_instance = PatchOperation.from_json(json)
# print the JSON string representation of the object
print(PatchOperation.to_json())

# convert the object into a dict
patch_operation_dict = patch_operation_instance.to_dict()
# create an instance of PatchOperation from a dict
patch_operation_from_dict = PatchOperation.from_dict(patch_operation_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


