# PredefinedPackageDimensions

An enumeration of predefined parcel tokens. If you specify a `PredefinedPackageDimensions` token, you are not obligated to use a branded package from a carrier. For example, if you specify the `FedEx_Box_10kg` token, you do not have to use that particular package from FedEx. You are only obligated to use a box that matches the dimensions specified by the token. Note: Carriers can have restrictions on the type of package allowed for certain ship methods. Check the carrier website for details. Example: Flat rate pricing is available when materials are sent by USPS in a USPS-produced Flat Rate envelope or box.

## Enum

* `FED_EX_BOX_10KG` (value: `'FedEx_Box_10kg'`)

* `FED_EX_BOX_25KG` (value: `'FedEx_Box_25kg'`)

* `FED_EX_BOX_EXTRA_LARGE_1` (value: `'FedEx_Box_Extra_Large_1'`)

* `FED_EX_BOX_EXTRA_LARGE_2` (value: `'FedEx_Box_Extra_Large_2'`)

* `FED_EX_BOX_LARGE_1` (value: `'FedEx_Box_Large_1'`)

* `FED_EX_BOX_LARGE_2` (value: `'FedEx_Box_Large_2'`)

* `FED_EX_BOX_MEDIUM_1` (value: `'FedEx_Box_Medium_1'`)

* `FED_EX_BOX_MEDIUM_2` (value: `'FedEx_Box_Medium_2'`)

* `FED_EX_BOX_SMALL_1` (value: `'FedEx_Box_Small_1'`)

* `FED_EX_BOX_SMALL_2` (value: `'FedEx_Box_Small_2'`)

* `FED_EX_ENVELOPE` (value: `'FedEx_Envelope'`)

* `FED_EX_PADDED_PAK` (value: `'FedEx_Padded_Pak'`)

* `FED_EX_PAK_1` (value: `'FedEx_Pak_1'`)

* `FED_EX_PAK_2` (value: `'FedEx_Pak_2'`)

* `FED_EX_TUBE` (value: `'FedEx_Tube'`)

* `FED_EX_XL_PAK` (value: `'FedEx_XL_Pak'`)

* `UPS_BOX_10KG` (value: `'UPS_Box_10kg'`)

* `UPS_BOX_25KG` (value: `'UPS_Box_25kg'`)

* `UPS_EXPRESS_BOX` (value: `'UPS_Express_Box'`)

* `UPS_EXPRESS_BOX_LARGE` (value: `'UPS_Express_Box_Large'`)

* `UPS_EXPRESS_BOX_MEDIUM` (value: `'UPS_Express_Box_Medium'`)

* `UPS_EXPRESS_BOX_SMALL` (value: `'UPS_Express_Box_Small'`)

* `UPS_EXPRESS_ENVELOPE` (value: `'UPS_Express_Envelope'`)

* `UPS_EXPRESS_HARD_PAK` (value: `'UPS_Express_Hard_Pak'`)

* `UPS_EXPRESS_LEGAL_ENVELOPE` (value: `'UPS_Express_Legal_Envelope'`)

* `UPS_EXPRESS_PAK` (value: `'UPS_Express_Pak'`)

* `UPS_EXPRESS_TUBE` (value: `'UPS_Express_Tube'`)

* `UPS_LABORATORY_PAK` (value: `'UPS_Laboratory_Pak'`)

* `UPS_PAD_PAK` (value: `'UPS_Pad_Pak'`)

* `UPS_PALLET` (value: `'UPS_Pallet'`)

* `USPS_CARD` (value: `'USPS_Card'`)

* `USPS_FLAT` (value: `'USPS_Flat'`)

* `USPS_FLAT_RATE_CARDBOARD_ENVELOPE` (value: `'USPS_FlatRateCardboardEnvelope'`)

* `USPS_FLAT_RATE_ENVELOPE` (value: `'USPS_FlatRateEnvelope'`)

* `USPS_FLAT_RATE_GIFT_CARD_ENVELOPE` (value: `'USPS_FlatRateGiftCardEnvelope'`)

* `USPS_FLAT_RATE_LEGAL_ENVELOPE` (value: `'USPS_FlatRateLegalEnvelope'`)

* `USPS_FLAT_RATE_PADDED_ENVELOPE` (value: `'USPS_FlatRatePaddedEnvelope'`)

* `USPS_FLAT_RATE_WINDOW_ENVELOPE` (value: `'USPS_FlatRateWindowEnvelope'`)

* `USPS_LARGE_FLAT_RATE_BOARD_GAME_BOX` (value: `'USPS_LargeFlatRateBoardGameBox'`)

* `USPS_LARGE_FLAT_RATE_BOX` (value: `'USPS_LargeFlatRateBox'`)

* `USPS_LETTER` (value: `'USPS_Letter'`)

* `USPS_MEDIUM_FLAT_RATE_BOX1` (value: `'USPS_MediumFlatRateBox1'`)

* `USPS_MEDIUM_FLAT_RATE_BOX2` (value: `'USPS_MediumFlatRateBox2'`)

* `USPS_REGIONAL_RATE_BOX_A1` (value: `'USPS_RegionalRateBoxA1'`)

* `USPS_REGIONAL_RATE_BOX_A2` (value: `'USPS_RegionalRateBoxA2'`)

* `USPS_REGIONAL_RATE_BOX_B1` (value: `'USPS_RegionalRateBoxB1'`)

* `USPS_REGIONAL_RATE_BOX_B2` (value: `'USPS_RegionalRateBoxB2'`)

* `USPS_REGIONAL_RATE_BOX_C` (value: `'USPS_RegionalRateBoxC'`)

* `USPS_SMALL_FLAT_RATE_BOX` (value: `'USPS_SmallFlatRateBox'`)

* `USPS_SMALL_FLAT_RATE_ENVELOPE` (value: `'USPS_SmallFlatRateEnvelope'`)

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


