# coding: utf-8

"""
    Selling Partner API for Merchant Fulfillment

    With the Selling Partner API for Merchant Fulfillment, you can build applications that sellers can use to purchase shipping for non-Prime and Prime orders using Amazon's Buy Shipping Services.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from py_sp_api.generated.merchantFulfillmentV0.models.available_carrier_will_pick_up_option import AvailableCarrierWillPickUpOption
from py_sp_api.generated.merchantFulfillmentV0.models.available_delivery_experience_option import AvailableDeliveryExperienceOption
from typing import Optional, Set
from typing_extensions import Self

class AvailableShippingServiceOptions(BaseModel):
    """
    The available shipping service options.
    """ # noqa: E501
    available_carrier_will_pick_up_options: List[AvailableCarrierWillPickUpOption] = Field(description="List of available carrier pickup options.", alias="AvailableCarrierWillPickUpOptions")
    available_delivery_experience_options: List[AvailableDeliveryExperienceOption] = Field(description="List of available delivery experience options.", alias="AvailableDeliveryExperienceOptions")
    __properties: ClassVar[List[str]] = ["AvailableCarrierWillPickUpOptions", "AvailableDeliveryExperienceOptions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AvailableShippingServiceOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in available_carrier_will_pick_up_options (list)
        _items = []
        if self.available_carrier_will_pick_up_options:
            for _item_available_carrier_will_pick_up_options in self.available_carrier_will_pick_up_options:
                if _item_available_carrier_will_pick_up_options:
                    _items.append(_item_available_carrier_will_pick_up_options.to_dict())
            _dict['AvailableCarrierWillPickUpOptions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in available_delivery_experience_options (list)
        _items = []
        if self.available_delivery_experience_options:
            for _item_available_delivery_experience_options in self.available_delivery_experience_options:
                if _item_available_delivery_experience_options:
                    _items.append(_item_available_delivery_experience_options.to_dict())
            _dict['AvailableDeliveryExperienceOptions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AvailableShippingServiceOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "AvailableCarrierWillPickUpOptions": [AvailableCarrierWillPickUpOption.from_dict(_item) for _item in obj["AvailableCarrierWillPickUpOptions"]] if obj.get("AvailableCarrierWillPickUpOptions") is not None else None,
            "AvailableDeliveryExperienceOptions": [AvailableDeliveryExperienceOption.from_dict(_item) for _item in obj["AvailableDeliveryExperienceOptions"]] if obj.get("AvailableDeliveryExperienceOptions") is not None else None
        })
        return _obj


