# coding: utf-8

"""
    Selling Partner API for Merchant Fulfillment

    With the Selling Partner API for Merchant Fulfillment, you can build applications that sellers can use to purchase shipping for non-Prime and Prime orders using Amazon's Buy Shipping Services.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RejectedShippingService(BaseModel):
    """
    Information about a rejected shipping service
    """ # noqa: E501
    carrier_name: StrictStr = Field(description="The rejected shipping carrier name. For example, USPS.", alias="CarrierName")
    shipping_service_name: StrictStr = Field(description="The rejected shipping service localized name. For example, FedEx Standard Overnight.", alias="ShippingServiceName")
    shipping_service_id: StrictStr = Field(description="An Amazon-defined shipping service identifier.", alias="ShippingServiceId")
    rejection_reason_code: StrictStr = Field(description="A reason code meant to be consumed programatically. For example, `CARRIER_CANNOT_SHIP_TO_POBOX`.", alias="RejectionReasonCode")
    rejection_reason_message: Optional[StrictStr] = Field(default=None, description="A localized human readable description of the rejected reason.", alias="RejectionReasonMessage")
    __properties: ClassVar[List[str]] = ["CarrierName", "ShippingServiceName", "ShippingServiceId", "RejectionReasonCode", "RejectionReasonMessage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RejectedShippingService from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RejectedShippingService from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CarrierName": obj.get("CarrierName"),
            "ShippingServiceName": obj.get("ShippingServiceName"),
            "ShippingServiceId": obj.get("ShippingServiceId"),
            "RejectionReasonCode": obj.get("RejectionReasonCode"),
            "RejectionReasonMessage": obj.get("RejectionReasonMessage")
        })
        return _obj


