# AutomatedShippingSettings

Contains information regarding the Shipping Settings Automation program, such as whether the order's shipping settings were generated automatically, and what those settings are.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**has_automated_shipping_settings** | **bool** | When true, this order has automated shipping settings generated by Amazon. This order could be identified as an SSA order. | [optional] 
**automated_carrier** | **str** | Auto-generated carrier for SSA orders. | [optional] 
**automated_ship_method** | **str** | Auto-generated ship method for SSA orders. | [optional] 

## Example

```python
from py_sp_api.generated.ordersV0.models.automated_shipping_settings import AutomatedShippingSettings

# TODO update the JSON string below
json = "{}"
# create an instance of AutomatedShippingSettings from a JSON string
automated_shipping_settings_instance = AutomatedShippingSettings.from_json(json)
# print the JSON string representation of the object
print(AutomatedShippingSettings.to_json())

# convert the object into a dict
automated_shipping_settings_dict = automated_shipping_settings_instance.to_dict()
# create an instance of AutomatedShippingSettings from a dict
automated_shipping_settings_from_dict = AutomatedShippingSettings.from_dict(automated_shipping_settings_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


