# coding: utf-8

"""
    Orders v0

    Use the Orders Selling Partner API to programmatically retrieve order information. With this API, you can develop fast, flexible, and custom applications to manage order synchronization, perform order research, and create demand-based decision support tools.   _Note:_ For the JP, AU, and SG marketplaces, the Orders API supports orders from 2016 onward. For all other marketplaces, the Orders API supports orders for the last two years (orders older than this don't show up in the response).

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.ordersV0.models.tax_classification import TaxClassification
from typing import Optional, Set
from typing_extensions import Self

class BuyerTaxInfo(BaseModel):
    """
    Tax information about the buyer.
    """ # noqa: E501
    company_legal_name: Optional[StrictStr] = Field(default=None, description="The legal name of the company.", alias="CompanyLegalName")
    taxing_region: Optional[StrictStr] = Field(default=None, description="The country or region imposing the tax.", alias="TaxingRegion")
    tax_classifications: Optional[List[TaxClassification]] = Field(default=None, description="A list of tax classifications that apply to the order.", alias="TaxClassifications")
    __properties: ClassVar[List[str]] = ["CompanyLegalName", "TaxingRegion", "TaxClassifications"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BuyerTaxInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in tax_classifications (list)
        _items = []
        if self.tax_classifications:
            for _item_tax_classifications in self.tax_classifications:
                if _item_tax_classifications:
                    _items.append(_item_tax_classifications.to_dict())
            _dict['TaxClassifications'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BuyerTaxInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CompanyLegalName": obj.get("CompanyLegalName"),
            "TaxingRegion": obj.get("TaxingRegion"),
            "TaxClassifications": [TaxClassification.from_dict(_item) for _item in obj["TaxClassifications"]] if obj.get("TaxClassifications") is not None else None
        })
        return _obj


