# coding: utf-8

"""
    Orders v0

    Use the Orders Selling Partner API to programmatically retrieve order information. With this API, you can develop fast, flexible, and custom applications to manage order synchronization, perform order research, and create demand-based decision support tools.   _Note:_ For the JP, AU, and SG marketplaces, the Orders API supports orders from 2016 onward. For all other marketplaces, the Orders API supports orders for the last two years (orders older than this don't show up in the response).

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.ordersV0.models.other_delivery_attributes import OtherDeliveryAttributes
from py_sp_api.generated.ordersV0.models.preferred_delivery_time import PreferredDeliveryTime
from typing import Optional, Set
from typing_extensions import Self

class DeliveryPreferences(BaseModel):
    """
    Contains all of the delivery instructions provided by the customer for the shipping address.
    """ # noqa: E501
    drop_off_location: Optional[StrictStr] = Field(default=None, description="Drop-off location selected by the customer.", alias="DropOffLocation")
    preferred_delivery_time: Optional[PreferredDeliveryTime] = Field(default=None, alias="PreferredDeliveryTime")
    other_attributes: Optional[List[OtherDeliveryAttributes]] = Field(default=None, description="Enumerated list of miscellaneous delivery attributes associated with the shipping address.", alias="OtherAttributes")
    address_instructions: Optional[StrictStr] = Field(default=None, description="Building instructions, nearby landmark or navigation instructions.", alias="AddressInstructions")
    __properties: ClassVar[List[str]] = ["DropOffLocation", "PreferredDeliveryTime", "OtherAttributes", "AddressInstructions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeliveryPreferences from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of preferred_delivery_time
        if self.preferred_delivery_time:
            _dict['PreferredDeliveryTime'] = self.preferred_delivery_time.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeliveryPreferences from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "DropOffLocation": obj.get("DropOffLocation"),
            "PreferredDeliveryTime": PreferredDeliveryTime.from_dict(obj["PreferredDeliveryTime"]) if obj.get("PreferredDeliveryTime") is not None else None,
            "OtherAttributes": obj.get("OtherAttributes"),
            "AddressInstructions": obj.get("AddressInstructions")
        })
        return _obj


