# coding: utf-8

"""
    Orders v0

    Use the Orders Selling Partner API to programmatically retrieve order information. With this API, you can develop fast, flexible, and custom applications to manage order synchronization, perform order research, and create demand-based decision support tools.   _Note:_ For the JP, AU, and SG marketplaces, the Orders API supports orders from 2016 onward. For all other marketplaces, the Orders API supports orders for the last two years (orders older than this don't show up in the response).

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.ordersV0.models.buyer_customized_info_detail import BuyerCustomizedInfoDetail
from py_sp_api.generated.ordersV0.models.money import Money
from typing import Optional, Set
from typing_extensions import Self

class ItemBuyerInfo(BaseModel):
    """
    A single item's buyer information.
    """ # noqa: E501
    buyer_customized_info: Optional[BuyerCustomizedInfoDetail] = Field(default=None, alias="BuyerCustomizedInfo")
    gift_wrap_price: Optional[Money] = Field(default=None, alias="GiftWrapPrice")
    gift_wrap_tax: Optional[Money] = Field(default=None, alias="GiftWrapTax")
    gift_message_text: Optional[StrictStr] = Field(default=None, description="A gift message provided by the buyer.  **Note**: This attribute is only available for MFN (fulfilled by seller) orders.", alias="GiftMessageText")
    gift_wrap_level: Optional[StrictStr] = Field(default=None, description="The gift wrap level specified by the buyer.", alias="GiftWrapLevel")
    __properties: ClassVar[List[str]] = ["BuyerCustomizedInfo", "GiftWrapPrice", "GiftWrapTax", "GiftMessageText", "GiftWrapLevel"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ItemBuyerInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of buyer_customized_info
        if self.buyer_customized_info:
            _dict['BuyerCustomizedInfo'] = self.buyer_customized_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gift_wrap_price
        if self.gift_wrap_price:
            _dict['GiftWrapPrice'] = self.gift_wrap_price.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gift_wrap_tax
        if self.gift_wrap_tax:
            _dict['GiftWrapTax'] = self.gift_wrap_tax.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ItemBuyerInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "BuyerCustomizedInfo": BuyerCustomizedInfoDetail.from_dict(obj["BuyerCustomizedInfo"]) if obj.get("BuyerCustomizedInfo") is not None else None,
            "GiftWrapPrice": Money.from_dict(obj["GiftWrapPrice"]) if obj.get("GiftWrapPrice") is not None else None,
            "GiftWrapTax": Money.from_dict(obj["GiftWrapTax"]) if obj.get("GiftWrapTax") is not None else None,
            "GiftMessageText": obj.get("GiftMessageText"),
            "GiftWrapLevel": obj.get("GiftWrapLevel")
        })
        return _obj


