# coding: utf-8

"""
    Orders v0

    Use the Orders Selling Partner API to programmatically retrieve order information. With this API, you can develop fast, flexible, and custom applications to manage order synchronization, perform order research, and create demand-based decision support tools.   _Note:_ For the JP, AU, and SG marketplaces, the Orders API supports orders from 2016 onward. For all other marketplaces, the Orders API supports orders for the last two years (orders older than this don't show up in the response).

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.ordersV0.models.business_hours import BusinessHours
from py_sp_api.generated.ordersV0.models.exception_dates import ExceptionDates
from typing import Optional, Set
from typing_extensions import Self

class PreferredDeliveryTime(BaseModel):
    """
    The time window when the delivery is preferred.
    """ # noqa: E501
    business_hours: Optional[List[BusinessHours]] = Field(default=None, description="Business hours when the business is open for deliveries.", alias="BusinessHours")
    exception_dates: Optional[List[ExceptionDates]] = Field(default=None, description="Dates when the business is closed during the next 30 days.", alias="ExceptionDates")
    __properties: ClassVar[List[str]] = ["BusinessHours", "ExceptionDates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PreferredDeliveryTime from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in business_hours (list)
        _items = []
        if self.business_hours:
            for _item_business_hours in self.business_hours:
                if _item_business_hours:
                    _items.append(_item_business_hours.to_dict())
            _dict['BusinessHours'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in exception_dates (list)
        _items = []
        if self.exception_dates:
            for _item_exception_dates in self.exception_dates:
                if _item_exception_dates:
                    _items.append(_item_exception_dates.to_dict())
            _dict['ExceptionDates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PreferredDeliveryTime from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "BusinessHours": [BusinessHours.from_dict(_item) for _item in obj["BusinessHours"]] if obj.get("BusinessHours") is not None else None,
            "ExceptionDates": [ExceptionDates.from_dict(_item) for _item in obj["ExceptionDates"]] if obj.get("ExceptionDates") is not None else None
        })
        return _obj


