# coding: utf-8

"""
    Orders v0

    Use the Orders Selling Partner API to programmatically retrieve order information. With this API, you can develop fast, flexible, and custom applications to manage order synchronization, perform order research, and create demand-based decision support tools.   _Note:_ For the JP, AU, and SG marketplaces, the Orders API supports orders from 2016 onward. For all other marketplaces, the Orders API supports orders for the last two years (orders older than this don't show up in the response).

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.ordersV0.models.measurement import Measurement
from typing import Optional, Set
from typing_extensions import Self

class SubstitutionOption(BaseModel):
    """
    Substitution options for an order item.
    """ # noqa: E501
    asin: Optional[StrictStr] = Field(default=None, description="The item's Amazon Standard Identification Number (ASIN).", alias="ASIN")
    quantity_ordered: Optional[StrictInt] = Field(default=None, description="The number of items to be picked for this substitution option. ", alias="QuantityOrdered")
    seller_sku: Optional[StrictStr] = Field(default=None, description="The item's seller stock keeping unit (SKU).", alias="SellerSKU")
    title: Optional[StrictStr] = Field(default=None, description="The item's title.", alias="Title")
    measurement: Optional[Measurement] = Field(default=None, alias="Measurement")
    __properties: ClassVar[List[str]] = ["ASIN", "QuantityOrdered", "SellerSKU", "Title", "Measurement"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubstitutionOption from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of measurement
        if self.measurement:
            _dict['Measurement'] = self.measurement.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubstitutionOption from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ASIN": obj.get("ASIN"),
            "QuantityOrdered": obj.get("QuantityOrdered"),
            "SellerSKU": obj.get("SellerSKU"),
            "Title": obj.get("Title"),
            "Measurement": Measurement.from_dict(obj["Measurement"]) if obj.get("Measurement") is not None else None
        })
        return _obj


