# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer information for Amazon Marketplace products.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DetailedShippingTimeType(BaseModel):
    """
    The time range in which an item will likely be shipped once an order has been placed.
    """ # noqa: E501
    minimum_hours: Optional[StrictInt] = Field(default=None, description="The minimum time, in hours, that the item will likely be shipped after the order has been placed.", alias="minimumHours")
    maximum_hours: Optional[StrictInt] = Field(default=None, description="The maximum time, in hours, that the item will likely be shipped after the order has been placed.", alias="maximumHours")
    available_date: Optional[StrictStr] = Field(default=None, description="The date when the item will be available for shipping. Only displayed for items that are not currently available for shipping.", alias="availableDate")
    availability_type: Optional[StrictStr] = Field(default=None, description="Indicates whether the item is available for shipping now, or on a known or an unknown date in the future. If known, the availableDate property indicates the date that the item will be available for shipping. Possible values: NOW, FUTURE_WITHOUT_DATE, FUTURE_WITH_DATE.", alias="availabilityType")
    __properties: ClassVar[List[str]] = ["minimumHours", "maximumHours", "availableDate", "availabilityType"]

    @field_validator('availability_type')
    def availability_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NOW', 'FUTURE_WITHOUT_DATE', 'FUTURE_WITH_DATE']):
            raise ValueError("must be one of enum values ('NOW', 'FUTURE_WITHOUT_DATE', 'FUTURE_WITH_DATE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DetailedShippingTimeType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DetailedShippingTimeType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "minimumHours": obj.get("minimumHours"),
            "maximumHours": obj.get("maximumHours"),
            "availableDate": obj.get("availableDate"),
            "availabilityType": obj.get("availabilityType")
        })
        return _obj


