# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer information for Amazon Marketplace products.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.productPricingV0.models.get_offers_http_status_line import GetOffersHttpStatusLine
from py_sp_api.generated.productPricingV0.models.get_offers_response import GetOffersResponse
from py_sp_api.generated.productPricingV0.models.http_response_headers import HttpResponseHeaders
from py_sp_api.generated.productPricingV0.models.item_offers_request_params import ItemOffersRequestParams
from typing import Optional, Set
from typing_extensions import Self

class ItemOffersResponse(BaseModel):
    """
    ItemOffersResponse
    """ # noqa: E501
    headers: Optional[HttpResponseHeaders] = None
    status: Optional[GetOffersHttpStatusLine] = None
    body: GetOffersResponse
    request: ItemOffersRequestParams
    __properties: ClassVar[List[str]] = ["headers", "status", "body", "request"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ItemOffersResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of headers
        if self.headers:
            _dict['headers'] = self.headers.to_dict()
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of body
        if self.body:
            _dict['body'] = self.body.to_dict()
        # override the default output from pydantic by calling `to_dict()` of request
        if self.request:
            _dict['request'] = self.request.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ItemOffersResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "headers": HttpResponseHeaders.from_dict(obj["headers"]) if obj.get("headers") is not None else None,
            "status": GetOffersHttpStatusLine.from_dict(obj["status"]) if obj.get("status") is not None else None,
            "body": GetOffersResponse.from_dict(obj["body"]) if obj.get("body") is not None else None,
            "request": ItemOffersRequestParams.from_dict(obj["request"]) if obj.get("request") is not None else None
        })
        return _obj


