# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer information for Amazon Marketplace products.

    The version of the OpenAPI document: v0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.productPricingV0.models.customer_type import CustomerType
from py_sp_api.generated.productPricingV0.models.http_method import HttpMethod
from py_sp_api.generated.productPricingV0.models.item_condition import ItemCondition
from typing import Optional, Set
from typing_extensions import Self

class ListingOffersRequest(BaseModel):
    """
    ListingOffersRequest
    """ # noqa: E501
    uri: StrictStr = Field(description="The resource path of the operation you are calling in batch without any query parameters.  If you are calling `getItemOffersBatch`, supply the path of `getItemOffers`.  **Example:** `/products/pricing/v0/items/B000P6Q7MY/offers`  If you are calling `getListingOffersBatch`, supply the path of `getListingOffers`.  **Example:** `/products/pricing/v0/listings/B000P6Q7MY/offers`")
    method: HttpMethod
    headers: Optional[Dict[str, StrictStr]] = Field(default=None, description="A mapping of additional HTTP headers to send/receive for the individual batch request.")
    marketplace_id: StrictStr = Field(description="A marketplace identifier. Specifies the marketplace for which prices are returned.", alias="MarketplaceId")
    item_condition: ItemCondition = Field(alias="ItemCondition")
    customer_type: Optional[CustomerType] = Field(default=None, alias="CustomerType")
    __properties: ClassVar[List[str]] = ["uri", "method", "headers", "MarketplaceId", "ItemCondition", "CustomerType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListingOffersRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListingOffersRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uri": obj.get("uri"),
            "method": obj.get("method"),
            "headers": obj.get("headers"),
            "MarketplaceId": obj.get("MarketplaceId"),
            "ItemCondition": obj.get("ItemCondition"),
            "CustomerType": obj.get("CustomerType")
        })
        return _obj


