# coding: utf-8

"""
    Selling Partner API for Replenishment

    The Selling Partner API for Replenishment (Replenishment API) provides programmatic access to replenishment program metrics and offers. These programs provide recurring delivery of any replenishable item at a frequency chosen by the customer.  The Replenishment API is available worldwide wherever Amazon Subscribe & Save is available or is supported. The API is available to vendors and FBA selling partners.

    The version of the OpenAPI document: 2022-11-07
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class EligibilityStatus(str, Enum):
    """
    The current eligibility status of an offer.
    """

    """
    allowed enum values
    """
    ELIGIBLE = 'ELIGIBLE'
    INELIGIBLE = 'INELIGIBLE'
    SUSPENDED = 'SUSPENDED'
    REPLENISHMENT_ONLY_ORDERING = 'REPLENISHMENT_ONLY_ORDERING'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of EligibilityStatus from a JSON string"""
        return cls(json.loads(json_str))


