# coding: utf-8

"""
    Selling Partner API for Services

    With the Services API, you can build applications that help service providers get and modify their service orders and manage their resources.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.services.models.appointment_time import AppointmentTime
from py_sp_api.generated.services.models.poa import Poa
from py_sp_api.generated.services.models.technician import Technician
from typing import Optional, Set
from typing_extensions import Self

class Appointment(BaseModel):
    """
    The details of an appointment.
    """ # noqa: E501
    appointment_id: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=100)]] = Field(default=None, description="The appointment identifier.", alias="appointmentId")
    appointment_status: Optional[StrictStr] = Field(default=None, description="The status of the appointment.", alias="appointmentStatus")
    appointment_time: Optional[AppointmentTime] = Field(default=None, alias="appointmentTime")
    assigned_technicians: Optional[Annotated[List[Technician], Field(min_length=1)]] = Field(default=None, description="A list of technicians assigned to the service job.", alias="assignedTechnicians")
    rescheduled_appointment_id: Optional[Annotated[str, Field(min_length=5, strict=True, max_length=100)]] = Field(default=None, description="The appointment identifier.", alias="rescheduledAppointmentId")
    poa: Optional[Poa] = None
    __properties: ClassVar[List[str]] = ["appointmentId", "appointmentStatus", "appointmentTime", "assignedTechnicians", "rescheduledAppointmentId", "poa"]

    @field_validator('appointment_status')
    def appointment_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ACTIVE', 'CANCELLED', 'COMPLETED']):
            raise ValueError("must be one of enum values ('ACTIVE', 'CANCELLED', 'COMPLETED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Appointment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of appointment_time
        if self.appointment_time:
            _dict['appointmentTime'] = self.appointment_time.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in assigned_technicians (list)
        _items = []
        if self.assigned_technicians:
            for _item_assigned_technicians in self.assigned_technicians:
                if _item_assigned_technicians:
                    _items.append(_item_assigned_technicians.to_dict())
            _dict['assignedTechnicians'] = _items
        # override the default output from pydantic by calling `to_dict()` of poa
        if self.poa:
            _dict['poa'] = self.poa.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Appointment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appointmentId": obj.get("appointmentId"),
            "appointmentStatus": obj.get("appointmentStatus"),
            "appointmentTime": AppointmentTime.from_dict(obj["appointmentTime"]) if obj.get("appointmentTime") is not None else None,
            "assignedTechnicians": [Technician.from_dict(_item) for _item in obj["assignedTechnicians"]] if obj.get("assignedTechnicians") is not None else None,
            "rescheduledAppointmentId": obj.get("rescheduledAppointmentId"),
            "poa": Poa.from_dict(obj["poa"]) if obj.get("poa") is not None else None
        })
        return _obj


