# coding: utf-8

"""
    Selling Partner API for Services

    With the Services API, you can build applications that help service providers get and modify their service orders and manage their resources.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Buyer(BaseModel):
    """
    Information about the buyer.
    """ # noqa: E501
    buyer_id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="The identifier of the buyer.", alias="buyerId")
    name: Optional[StrictStr] = Field(default=None, description="The name of the buyer.")
    phone: Optional[StrictStr] = Field(default=None, description="The phone number of the buyer.")
    is_prime_member: Optional[StrictBool] = Field(default=None, description="When true, the service is for an Amazon Prime buyer.", alias="isPrimeMember")
    __properties: ClassVar[List[str]] = ["buyerId", "name", "phone", "isPrimeMember"]

    @field_validator('buyer_id')
    def buyer_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Z0-9]*$", value):
            raise ValueError(r"must validate the regular expression /^[A-Z0-9]*$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Buyer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Buyer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "buyerId": obj.get("buyerId"),
            "name": obj.get("name"),
            "phone": obj.get("phone"),
            "isPrimeMember": obj.get("isPrimeMember")
        })
        return _obj


