# coding: utf-8

"""
    Selling Partner API for Services

    With the Services API, you can build applications that help service providers get and modify their service orders and manage their resources.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.services.models.range_capacity import RangeCapacity
from typing import Optional, Set
from typing_extensions import Self

class RangeSlotCapacity(BaseModel):
    """
    Response schema for the `getRangeSlotCapacity` operation.
    """ # noqa: E501
    resource_id: Optional[StrictStr] = Field(default=None, description="Resource Identifier.", alias="resourceId")
    capacities: Optional[List[RangeCapacity]] = Field(default=None, description="Array of range capacities where each entry is for a specific capacity type.")
    next_page_token: Optional[StrictStr] = Field(default=None, description="Next page token, if there are more pages.", alias="nextPageToken")
    __properties: ClassVar[List[str]] = ["resourceId", "capacities", "nextPageToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RangeSlotCapacity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in capacities (list)
        _items = []
        if self.capacities:
            for _item_capacities in self.capacities:
                if _item_capacities:
                    _items.append(_item_capacities.to_dict())
            _dict['capacities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RangeSlotCapacity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "resourceId": obj.get("resourceId"),
            "capacities": [RangeCapacity.from_dict(_item) for _item in obj["capacities"]] if obj.get("capacities") is not None else None,
            "nextPageToken": obj.get("nextPageToken")
        })
        return _obj


