# coding: utf-8

"""
    Selling Partner API for Shipping

    Provides programmatic access to Amazon Shipping APIs.   **Note:** If you are new to the Amazon Shipping API, refer to the latest version of <a href=\"https://developer-docs.amazon.com/amazon-shipping/docs/shipping-api-v2-reference\">Amazon Shipping API (v2)</a> on the <a href=\"https://developer-docs.amazon.com/amazon-shipping/\">Amazon Shipping Developer Documentation</a> site.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Address(BaseModel):
    """
    The address.
    """ # noqa: E501
    name: Annotated[str, Field(min_length=1, strict=True, max_length=50)] = Field(description="The name of the person, business or institution at that address.")
    address_line1: Annotated[str, Field(min_length=1, strict=True, max_length=60)] = Field(description="First line of that address.", alias="addressLine1")
    address_line2: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=60)]] = Field(default=None, description="Additional address information, if required.", alias="addressLine2")
    address_line3: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=60)]] = Field(default=None, description="Additional address information, if required.", alias="addressLine3")
    state_or_region: StrictStr = Field(description="The state or region where the person, business or institution is located.", alias="stateOrRegion")
    city: Annotated[str, Field(min_length=1, strict=True, max_length=50)] = Field(description="The city where the person, business or institution is located.")
    country_code: Annotated[str, Field(min_length=2, strict=True, max_length=2)] = Field(description="The two digit country code. In ISO 3166-1 alpha-2 format.", alias="countryCode")
    postal_code: Annotated[str, Field(min_length=1, strict=True, max_length=20)] = Field(description="The postal code of that address. It contains a series of letters or digits or both, sometimes including spaces or punctuation.", alias="postalCode")
    email: Optional[Annotated[str, Field(strict=True, max_length=64)]] = Field(default=None, description="The email address of the contact associated with the address.")
    copy_emails: Optional[Annotated[List[Annotated[str, Field(strict=True, max_length=64)]], Field(max_length=2)]] = Field(default=None, description="The email cc addresses of the contact associated with the address.", alias="copyEmails")
    phone_number: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=20)]] = Field(default=None, description="The phone number of the person, business or institution located at that address.", alias="phoneNumber")
    __properties: ClassVar[List[str]] = ["name", "addressLine1", "addressLine2", "addressLine3", "stateOrRegion", "city", "countryCode", "postalCode", "email", "copyEmails", "phoneNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Address from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Address from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "addressLine3": obj.get("addressLine3"),
            "stateOrRegion": obj.get("stateOrRegion"),
            "city": obj.get("city"),
            "countryCode": obj.get("countryCode"),
            "postalCode": obj.get("postalCode"),
            "email": obj.get("email"),
            "copyEmails": obj.get("copyEmails"),
            "phoneNumber": obj.get("phoneNumber")
        })
        return _obj


