# coding: utf-8

"""
    Selling Partner API for Shipping

    Provides programmatic access to Amazon Shipping APIs.   **Note:** If you are new to the Amazon Shipping API, refer to the latest version of <a href=\"https://developer-docs.amazon.com/amazon-shipping/docs/shipping-api-v2-reference\">Amazon Shipping API (v2)</a> on the <a href=\"https://developer-docs.amazon.com/amazon-shipping/\">Amazon Shipping Developer Documentation</a> site.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.shipping.models.currency import Currency
from py_sp_api.generated.shipping.models.service_type import ServiceType
from py_sp_api.generated.shipping.models.shipping_promise_set import ShippingPromiseSet
from py_sp_api.generated.shipping.models.weight import Weight
from typing import Optional, Set
from typing_extensions import Self

class Rate(BaseModel):
    """
    The available rate that can be used to send the shipment
    """ # noqa: E501
    rate_id: Optional[StrictStr] = Field(default=None, description="An identifier for the rate.", alias="rateId")
    total_charge: Optional[Currency] = Field(default=None, alias="totalCharge")
    billed_weight: Optional[Weight] = Field(default=None, alias="billedWeight")
    expiration_time: Optional[datetime] = Field(default=None, description="The time after which the offering will expire.", alias="expirationTime")
    service_type: Optional[ServiceType] = Field(default=None, alias="serviceType")
    promise: Optional[ShippingPromiseSet] = None
    __properties: ClassVar[List[str]] = ["rateId", "totalCharge", "billedWeight", "expirationTime", "serviceType", "promise"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Rate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of total_charge
        if self.total_charge:
            _dict['totalCharge'] = self.total_charge.to_dict()
        # override the default output from pydantic by calling `to_dict()` of billed_weight
        if self.billed_weight:
            _dict['billedWeight'] = self.billed_weight.to_dict()
        # override the default output from pydantic by calling `to_dict()` of promise
        if self.promise:
            _dict['promise'] = self.promise.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Rate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rateId": obj.get("rateId"),
            "totalCharge": Currency.from_dict(obj["totalCharge"]) if obj.get("totalCharge") is not None else None,
            "billedWeight": Weight.from_dict(obj["billedWeight"]) if obj.get("billedWeight") is not None else None,
            "expirationTime": obj.get("expirationTime"),
            "serviceType": obj.get("serviceType"),
            "promise": ShippingPromiseSet.from_dict(obj["promise"]) if obj.get("promise") is not None else None
        })
        return _obj


