# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class AccessPointType(str, Enum):
    """
    The type of access point, like counter (HELIX), lockers, etc.
    """

    """
    allowed enum values
    """
    HELIX = 'HELIX'
    CAMPUS_LOCKER = 'CAMPUS_LOCKER'
    OMNI_LOCKER = 'OMNI_LOCKER'
    ODIN_LOCKER = 'ODIN_LOCKER'
    DOBBY_LOCKER = 'DOBBY_LOCKER'
    CORE_LOCKER = 'CORE_LOCKER'
    ENUM_3P = '3P'
    CAMPUS_ROOM = 'CAMPUS_ROOM'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AccessPointType from a JSON string"""
        return cls(json.loads(json_str))


