# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.shippingV2.models.input_type import InputType
from py_sp_api.generated.shippingV2.models.validation_metadata import ValidationMetadata
from typing import Optional, Set
from typing_extensions import Self

class CarrierAccountInput(BaseModel):
    """
    Info About CarrierAccountInput
    """ # noqa: E501
    description_localization_key: Optional[StrictStr] = Field(default=None, description="descriptionLocalizationKey value .", alias="descriptionLocalizationKey")
    name: Optional[StrictStr] = Field(default=None, description="name value .")
    group_name: Optional[StrictStr] = Field(default=None, description="groupName value .", alias="groupName")
    input_type: Optional[InputType] = Field(default=None, alias="inputType")
    is_mandatory: Optional[StrictBool] = Field(default=None, description="mandatory or not  value .", alias="isMandatory")
    is_confidential: Optional[StrictBool] = Field(default=None, description="is value is Confidential .", alias="isConfidential")
    is_hidden: Optional[StrictBool] = Field(default=None, description="is value is hidden .", alias="isHidden")
    validation_metadata: Optional[List[ValidationMetadata]] = Field(default=None, description="A list of ValidationMetadata", alias="validationMetadata")
    __properties: ClassVar[List[str]] = ["descriptionLocalizationKey", "name", "groupName", "inputType", "isMandatory", "isConfidential", "isHidden", "validationMetadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CarrierAccountInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in validation_metadata (list)
        _items = []
        if self.validation_metadata:
            for _item_validation_metadata in self.validation_metadata:
                if _item_validation_metadata:
                    _items.append(_item_validation_metadata.to_dict())
            _dict['validationMetadata'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CarrierAccountInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "descriptionLocalizationKey": obj.get("descriptionLocalizationKey"),
            "name": obj.get("name"),
            "groupName": obj.get("groupName"),
            "inputType": obj.get("inputType"),
            "isMandatory": obj.get("isMandatory"),
            "isConfidential": obj.get("isConfidential"),
            "isHidden": obj.get("isHidden"),
            "validationMetadata": [ValidationMetadata.from_dict(_item) for _item in obj["validationMetadata"]] if obj.get("validationMetadata") is not None else None
        })
        return _obj


