# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.shippingV2.models.ineligible_rate import IneligibleRate
from py_sp_api.generated.shippingV2.models.rate import Rate
from typing import Optional, Set
from typing_extensions import Self

class GetRatesResult(BaseModel):
    """
    The payload for the getRates operation.
    """ # noqa: E501
    request_token: StrictStr = Field(description="A unique token generated to identify a getRates operation.", alias="requestToken")
    rates: List[Rate] = Field(description="A list of eligible shipping service offerings.")
    ineligible_rates: Optional[List[IneligibleRate]] = Field(default=None, description="A list of ineligible shipping service offerings.", alias="ineligibleRates")
    __properties: ClassVar[List[str]] = ["requestToken", "rates", "ineligibleRates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetRatesResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rates (list)
        _items = []
        if self.rates:
            for _item_rates in self.rates:
                if _item_rates:
                    _items.append(_item_rates.to_dict())
            _dict['rates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in ineligible_rates (list)
        _items = []
        if self.ineligible_rates:
            for _item_ineligible_rates in self.ineligible_rates:
                if _item_ineligible_rates:
                    _items.append(_item_ineligible_rates.to_dict())
            _dict['ineligibleRates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetRatesResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "requestToken": obj.get("requestToken"),
            "rates": [Rate.from_dict(_item) for _item in obj["rates"]] if obj.get("rates") is not None else None,
            "ineligibleRates": [IneligibleRate.from_dict(_item) for _item in obj["ineligibleRates"]] if obj.get("ineligibleRates") is not None else None
        })
        return _obj


