# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class IneligibilityReasonCode(str, Enum):
    """
    Reasons that make a shipment service offering ineligible.
    """

    """
    allowed enum values
    """
    NO_COVERAGE = 'NO_COVERAGE'
    PICKUP_SLOT_RESTRICTION = 'PICKUP_SLOT_RESTRICTION'
    UNSUPPORTED_VAS = 'UNSUPPORTED_VAS'
    VAS_COMBINATION_RESTRICTION = 'VAS_COMBINATION_RESTRICTION'
    SIZE_RESTRICTIONS = 'SIZE_RESTRICTIONS'
    WEIGHT_RESTRICTIONS = 'WEIGHT_RESTRICTIONS'
    LATE_DELIVERY = 'LATE_DELIVERY'
    PROGRAM_CONSTRAINTS = 'PROGRAM_CONSTRAINTS'
    TERMS_AND_CONDITIONS_NOT_ACCEPTED = 'TERMS_AND_CONDITIONS_NOT_ACCEPTED'
    UNKNOWN = 'UNKNOWN'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of IneligibilityReasonCode from a JSON string"""
        return cls(json.loads(json_str))


