# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Location(BaseModel):
    """
    The location where the person, business or institution is located.
    """ # noqa: E501
    state_or_region: Optional[StrictStr] = Field(default=None, description="The state, county or region where the person, business or institution is located.", alias="stateOrRegion")
    city: Optional[StrictStr] = Field(default=None, description="The city or town where the person, business or institution is located.")
    country_code: Optional[StrictStr] = Field(default=None, description="The two digit country code. Follows ISO 3166-1 alpha-2 format.", alias="countryCode")
    postal_code: Optional[StrictStr] = Field(default=None, description="The postal code of that address. It contains a series of letters or digits or both, sometimes including spaces or punctuation.", alias="postalCode")
    __properties: ClassVar[List[str]] = ["stateOrRegion", "city", "countryCode", "postalCode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Location from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Location from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "stateOrRegion": obj.get("stateOrRegion"),
            "city": obj.get("city"),
            "countryCode": obj.get("countryCode"),
            "postalCode": obj.get("postalCode")
        })
        return _obj


