# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.shippingV2.models.currency import Currency
from py_sp_api.generated.shippingV2.models.rate_item_id import RateItemID
from py_sp_api.generated.shippingV2.models.rate_item_type import RateItemType
from typing import Optional, Set
from typing_extensions import Self

class RateItem(BaseModel):
    """
    Rate Item for shipping (base cost, transaction fee, confirmation, insurance, etc.) Data source definition: 
    """ # noqa: E501
    rate_item_id: Optional[RateItemID] = Field(default=None, alias="rateItemID")
    rate_item_type: Optional[RateItemType] = Field(default=None, alias="rateItemType")
    rate_item_charge: Optional[Currency] = Field(default=None, alias="rateItemCharge")
    rate_item_name_localization: Optional[StrictStr] = Field(default=None, description="Used for the localization.", alias="rateItemNameLocalization")
    __properties: ClassVar[List[str]] = ["rateItemID", "rateItemType", "rateItemCharge", "rateItemNameLocalization"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RateItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of rate_item_charge
        if self.rate_item_charge:
            _dict['rateItemCharge'] = self.rate_item_charge.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RateItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rateItemID": obj.get("rateItemID"),
            "rateItemType": obj.get("rateItemType"),
            "rateItemCharge": Currency.from_dict(obj["rateItemCharge"]) if obj.get("rateItemCharge") is not None else None,
            "rateItemNameLocalization": obj.get("rateItemNameLocalization")
        })
        return _obj


