# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class RateItemID(str, Enum):
    """
    Unique ID for the rateItem.
    """

    """
    allowed enum values
    """
    BASE_RATE = 'BASE_RATE'
    TRANSACTION_FEE = 'TRANSACTION_FEE'
    ADULT_SIGNATURE_CONFIRMATION = 'ADULT_SIGNATURE_CONFIRMATION'
    SIGNATURE_CONFIRMATION = 'SIGNATURE_CONFIRMATION'
    NO_CONFIRMATION = 'NO_CONFIRMATION'
    WAIVE_SIGNATURE = 'WAIVE_SIGNATURE'
    IMPLIED_LIABILITY = 'IMPLIED_LIABILITY'
    HIDDEN_POSTAGE = 'HIDDEN_POSTAGE'
    DECLARED_VALUE = 'DECLARED_VALUE'
    SUNDAY_HOLIDAY_DELIVERY = 'SUNDAY_HOLIDAY_DELIVERY'
    DELIVERY_CONFIRMATION = 'DELIVERY_CONFIRMATION'
    IMPORT_DUTY_CHARGE = 'IMPORT_DUTY_CHARGE'
    VAT = 'VAT'
    NO_SATURDAY_DELIVERY = 'NO_SATURDAY_DELIVERY'
    INSURANCE = 'INSURANCE'
    COD = 'COD'
    FUEL_SURCHARGE = 'FUEL_SURCHARGE'
    INSPECTION_CHARGE = 'INSPECTION_CHARGE'
    DELIVERY_AREA_SURCHARGE = 'DELIVERY_AREA_SURCHARGE'
    WAYBILL_CHARGE = 'WAYBILL_CHARGE'
    AMAZON_SPONSORED_DISCOUNT = 'AMAZON_SPONSORED_DISCOUNT'
    INTEGRATOR_SPONSORED_DISCOUNT = 'INTEGRATOR_SPONSORED_DISCOUNT'
    OVERSIZE_SURCHARGE = 'OVERSIZE_SURCHARGE'
    CONGESTION_CHARGE = 'CONGESTION_CHARGE'
    RESIDENTIAL_SURCHARGE = 'RESIDENTIAL_SURCHARGE'
    ADDITIONAL_SURCHARGE = 'ADDITIONAL_SURCHARGE'
    SURCHARGE = 'SURCHARGE'
    REBATE = 'REBATE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RateItemID from a JSON string"""
        return cls(json.loads(json_str))


