# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class Status(str, Enum):
    """
    The status of the package being shipped.
    """

    """
    allowed enum values
    """
    PRETRANSIT = 'PreTransit'
    INTRANSIT = 'InTransit'
    DELIVERED = 'Delivered'
    LOST = 'Lost'
    OUTFORDELIVERY = 'OutForDelivery'
    REJECTED = 'Rejected'
    UNDELIVERABLE = 'Undeliverable'
    DELIVERYATTEMPTED = 'DeliveryAttempted'
    PICKUPCANCELLED = 'PickupCancelled'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Status from a JSON string"""
        return cls(json.loads(json_str))


