# coding: utf-8

"""
    Amazon Shipping API

    The Amazon Shipping API is designed to support outbound shipping use cases both for orders originating on Amazon-owned marketplaces as well as external channels/marketplaces. With these APIs, you can request shipping rates, create shipments, cancel shipments, and track shipments.

    The version of the OpenAPI document: v2
    Contact: swa-api-core@amazon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from py_sp_api.generated.shippingV2.models.document_format import DocumentFormat
from py_sp_api.generated.shippingV2.models.document_size import DocumentSize
from py_sp_api.generated.shippingV2.models.print_option import PrintOption
from typing import Optional, Set
from typing_extensions import Self

class SupportedDocumentSpecification(BaseModel):
    """
    Document specification that is supported for a service offering.
    """ # noqa: E501
    format: DocumentFormat
    size: DocumentSize
    print_options: List[PrintOption] = Field(description="A list of the format options for a label.", alias="printOptions")
    __properties: ClassVar[List[str]] = ["format", "size", "printOptions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SupportedDocumentSpecification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of size
        if self.size:
            _dict['size'] = self.size.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in print_options (list)
        _items = []
        if self.print_options:
            for _item_print_options in self.print_options:
                if _item_print_options:
                    _items.append(_item_print_options.to_dict())
            _dict['printOptions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SupportedDocumentSpecification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "format": obj.get("format"),
            "size": DocumentSize.from_dict(obj["size"]) if obj.get("size") is not None else None,
            "printOptions": [PrintOption.from_dict(_item) for _item in obj["printOptions"]] if obj.get("printOptions") is not None else None
        })
        return _obj


