# coding: utf-8

# flake8: noqa

"""
    Selling Partner API for Solicitations

    With the Solicitations API you can build applications that send non-critical solicitations to buyers. You can get a list of solicitation types that are available for an order that you specify, then call an operation that sends a solicitation to the buyer for that order. Buyers cannot respond to solicitations sent by this API, and these solicitations do not appear in the Messaging section of Seller Central or in the recipient's Message Center. The Solicitations API returns responses that are formed according to the <a href=https://tools.ietf.org/html/draft-kelly-json-hal-08>JSON Hypertext Application Language</a> (HAL) standard.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from py_sp_api.generated.solicitations.api.solicitations_api import SolicitationsApi

# import ApiClient
from py_sp_api.generated.solicitations.api_response import ApiResponse
from py_sp_api.generated.solicitations.api_client import ApiClient
from py_sp_api.generated.solicitations.configuration import Configuration
from py_sp_api.generated.solicitations.exceptions import OpenApiException
from py_sp_api.generated.solicitations.exceptions import ApiTypeError
from py_sp_api.generated.solicitations.exceptions import ApiValueError
from py_sp_api.generated.solicitations.exceptions import ApiKeyError
from py_sp_api.generated.solicitations.exceptions import ApiAttributeError
from py_sp_api.generated.solicitations.exceptions import ApiException

# import models into sdk package
from py_sp_api.generated.solicitations.models.create_product_review_and_seller_feedback_solicitation_response import CreateProductReviewAndSellerFeedbackSolicitationResponse
from py_sp_api.generated.solicitations.models.error import Error
from py_sp_api.generated.solicitations.models.get_schema_response import GetSchemaResponse
from py_sp_api.generated.solicitations.models.get_schema_response_links import GetSchemaResponseLinks
from py_sp_api.generated.solicitations.models.get_solicitation_action_response import GetSolicitationActionResponse
from py_sp_api.generated.solicitations.models.get_solicitation_action_response_embedded import GetSolicitationActionResponseEmbedded
from py_sp_api.generated.solicitations.models.get_solicitation_action_response_links import GetSolicitationActionResponseLinks
from py_sp_api.generated.solicitations.models.get_solicitation_actions_for_order_response import GetSolicitationActionsForOrderResponse
from py_sp_api.generated.solicitations.models.get_solicitation_actions_for_order_response_embedded import GetSolicitationActionsForOrderResponseEmbedded
from py_sp_api.generated.solicitations.models.get_solicitation_actions_for_order_response_links import GetSolicitationActionsForOrderResponseLinks
from py_sp_api.generated.solicitations.models.link_object import LinkObject
from py_sp_api.generated.solicitations.models.solicitations_action import SolicitationsAction

from .base_client import SPAPIClient
