# coding: utf-8

"""
    Selling Partner API for Supply Sources

    Manage configurations and capabilities of seller supply sources.

    The version of the OpenAPI document: 2020-07-01
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.supplySources_2020_07_01.models.supply_source_list_inner import SupplySourceListInner
from typing import Optional, Set
from typing_extensions import Self

class GetSupplySourcesResponse(BaseModel):
    """
    The paginated list of supply sources.
    """ # noqa: E501
    supply_sources: Optional[List[SupplySourceListInner]] = Field(default=None, description="The list of `SupplySource`s.", alias="supplySources")
    next_page_token: Optional[StrictStr] = Field(default=None, description="If present, use this pagination token to retrieve the next page of supply sources.", alias="nextPageToken")
    __properties: ClassVar[List[str]] = ["supplySources", "nextPageToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetSupplySourcesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in supply_sources (list)
        _items = []
        if self.supply_sources:
            for _item_supply_sources in self.supply_sources:
                if _item_supply_sources:
                    _items.append(_item_supply_sources.to_dict())
            _dict['supplySources'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetSupplySourcesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "supplySources": [SupplySourceListInner.from_dict(_item) for _item in obj["supplySources"]] if obj.get("supplySources") is not None else None,
            "nextPageToken": obj.get("nextPageToken")
        })
        return _obj


