# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Inventory Updates

    The Selling Partner API for Direct Fulfillment Inventory Updates provides programmatic access to a direct fulfillment vendor's inventory updates.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorDirectFulfillmentInventoryV1.models.item_quantity import ItemQuantity
from typing import Optional, Set
from typing_extensions import Self

class ItemDetails(BaseModel):
    """
    Updated inventory details for an item.
    """ # noqa: E501
    buyer_product_identifier: Optional[StrictStr] = Field(default=None, description="The buyer selected product identification of the item. Either buyerProductIdentifier or vendorProductIdentifier should be submitted.", alias="buyerProductIdentifier")
    vendor_product_identifier: Optional[StrictStr] = Field(default=None, description="The vendor selected product identification of the item. Either buyerProductIdentifier or vendorProductIdentifier should be submitted.", alias="vendorProductIdentifier")
    available_quantity: ItemQuantity = Field(alias="availableQuantity")
    is_obsolete: Optional[StrictBool] = Field(default=None, description="When true, the item is permanently unavailable.", alias="isObsolete")
    __properties: ClassVar[List[str]] = ["buyerProductIdentifier", "vendorProductIdentifier", "availableQuantity", "isObsolete"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ItemDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of available_quantity
        if self.available_quantity:
            _dict['availableQuantity'] = self.available_quantity.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ItemDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "buyerProductIdentifier": obj.get("buyerProductIdentifier"),
            "vendorProductIdentifier": obj.get("vendorProductIdentifier"),
            "availableQuantity": ItemQuantity.from_dict(obj["availableQuantity"]) if obj.get("availableQuantity") is not None else None,
            "isObsolete": obj.get("isObsolete")
        })
        return _obj


