# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Orders

    The Selling Partner API for Direct Fulfillment Orders provides programmatic access to a direct fulfillment vendor's order data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ScheduledDeliveryShipment(BaseModel):
    """
    Dates for the scheduled delivery shipments.
    """ # noqa: E501
    scheduled_delivery_service_type: Optional[StrictStr] = Field(default=None, description="Scheduled delivery service type.", alias="scheduledDeliveryServiceType")
    earliest_nominated_delivery_date: Optional[datetime] = Field(default=None, description="Earliest nominated delivery date for the scheduled delivery.", alias="earliestNominatedDeliveryDate")
    latest_nominated_delivery_date: Optional[datetime] = Field(default=None, description="Latest nominated delivery date for the scheduled delivery.", alias="latestNominatedDeliveryDate")
    __properties: ClassVar[List[str]] = ["scheduledDeliveryServiceType", "earliestNominatedDeliveryDate", "latestNominatedDeliveryDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScheduledDeliveryShipment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScheduledDeliveryShipment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scheduledDeliveryServiceType": obj.get("scheduledDeliveryServiceType"),
            "earliestNominatedDeliveryDate": obj.get("earliestNominatedDeliveryDate"),
            "latestNominatedDeliveryDate": obj.get("latestNominatedDeliveryDate")
        })
        return _obj


