# ShipmentDetails

Details about a shipment.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**shipped_date** | **datetime** | This field indicates the date of the departure of the shipment from vendor&#39;s location. Vendors are requested to send ASNs within 30 minutes of departure from their warehouse/distribution center or at least 6 hours prior to the appointment time at the Amazon destination warehouse, whichever is sooner. Shipped date mentioned in the Shipment Confirmation should not be in the future. | 
**shipment_status** | **str** | Indicate the shipment status. | 
**is_priority_shipment** | **bool** | Provide the priority of the shipment. | [optional] 
**vendor_order_number** | **str** | The vendor order number is a unique identifier generated by a vendor for their reference. | [optional] 
**estimated_delivery_date** | **datetime** | Date on which the shipment is expected to reach the buyer&#39;s warehouse. It needs to be an estimate based on the average transit time between the ship-from location and the destination. The exact appointment time will be provided by buyer and is potentially not known when creating the shipment confirmation. | [optional] 

## Example

```python
from py_sp_api.generated.vendorDirectFulfillmentShippingV1.models.shipment_details import ShipmentDetails

# TODO update the JSON string below
json = "{}"
# create an instance of ShipmentDetails from a JSON string
shipment_details_instance = ShipmentDetails.from_json(json)
# print the JSON string representation of the object
print(ShipmentDetails.to_json())

# convert the object into a dict
shipment_details_dict = shipment_details_instance.to_dict()
# create an instance of ShipmentDetails from a dict
shipment_details_from_dict = ShipmentDetails.from_dict(shipment_details_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


