# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Shipping

    The Selling Partner API for Direct Fulfillment Shipping provides programmatic access to a direct fulfillment vendor's shipping data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_sp_api.generated.vendorDirectFulfillmentShippingV1.models.shipment_status_update import ShipmentStatusUpdate
from typing import Optional, Set
from typing_extensions import Self

class SubmitShipmentStatusUpdatesRequest(BaseModel):
    """
    Represents the request payload for submitting updates to the status of shipments, containing an array of one or more ShipmentStatusUpdate objects.
    """ # noqa: E501
    shipment_status_updates: Optional[Annotated[List[ShipmentStatusUpdate], Field(min_length=1)]] = Field(default=None, description="Contains a list of one or more ShipmentStatusUpdate objects, each representing an update to the status of a specific shipment.", alias="shipmentStatusUpdates")
    __properties: ClassVar[List[str]] = ["shipmentStatusUpdates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubmitShipmentStatusUpdatesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in shipment_status_updates (list)
        _items = []
        if self.shipment_status_updates:
            for _item_shipment_status_updates in self.shipment_status_updates:
                if _item_shipment_status_updates:
                    _items.append(_item_shipment_status_updates.to_dict())
            _dict['shipmentStatusUpdates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubmitShipmentStatusUpdatesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "shipmentStatusUpdates": [ShipmentStatusUpdate.from_dict(_item) for _item in obj["shipmentStatusUpdates"]] if obj.get("shipmentStatusUpdates") is not None else None
        })
        return _obj


