# coding: utf-8

"""
    Selling Partner API for Direct Fulfillment Shipping

    The Selling Partner API for Direct Fulfillment Shipping provides programmatic access to a direct fulfillment vendor's shipping data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorDirectFulfillmentShippingV1.models.address import Address
from typing import Optional, Set
from typing_extensions import Self

class TaxRegistrationDetails(BaseModel):
    """
    Tax registration details of the entity.
    """ # noqa: E501
    tax_registration_type: Optional[StrictStr] = Field(default=None, description="Tax registration type for the entity.", alias="taxRegistrationType")
    tax_registration_number: StrictStr = Field(description="Tax registration number for the party. For example, VAT ID.", alias="taxRegistrationNumber")
    tax_registration_address: Optional[Address] = Field(default=None, alias="taxRegistrationAddress")
    tax_registration_messages: Optional[StrictStr] = Field(default=None, description="Tax registration message that can be used for additional tax related details.", alias="taxRegistrationMessages")
    __properties: ClassVar[List[str]] = ["taxRegistrationType", "taxRegistrationNumber", "taxRegistrationAddress", "taxRegistrationMessages"]

    @field_validator('tax_registration_type')
    def tax_registration_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['VAT', 'GST']):
            raise ValueError("must be one of enum values ('VAT', 'GST')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TaxRegistrationDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of tax_registration_address
        if self.tax_registration_address:
            _dict['taxRegistrationAddress'] = self.tax_registration_address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TaxRegistrationDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "taxRegistrationType": obj.get("taxRegistrationType"),
            "taxRegistrationNumber": obj.get("taxRegistrationNumber"),
            "taxRegistrationAddress": Address.from_dict(obj["taxRegistrationAddress"]) if obj.get("taxRegistrationAddress") is not None else None,
            "taxRegistrationMessages": obj.get("taxRegistrationMessages")
        })
        return _obj


