# ShipmentDetails

Details about a shipment.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**shipped_date** | **datetime** | The date of the shipment&#39;s departure from vendor&#39;s location. Vendors send ASNs within 30 minutes of departure from their warehouse/distribution center or six hours prior to the appointment time at the Amazon destination warehouse. The shipped date mentioned in the shipment confirmation cannot be in the future. | 
**shipment_status** | **str** | The shipment status. | 
**is_priority_shipment** | **bool** | Provide the priority of the shipment. | [optional] 
**vendor_order_number** | **str** | The vendor order number is a unique identifier generated by a vendor for their reference. | [optional] 
**estimated_delivery_date** | **datetime** | The date on which the shipment is expected to reach the buyer&#39;s warehouse. The date is estimated based on the average transit time between the ship-from location and the destination. Usually, the exact appointment time is unknown when creating the shipment confirmation and is later provided by the buyer. | [optional] 

## Example

```python
from py_sp_api.generated.vendorDirectFulfillmentShipping_2021_12_28.models.shipment_details import ShipmentDetails

# TODO update the JSON string below
json = "{}"
# create an instance of ShipmentDetails from a JSON string
shipment_details_instance = ShipmentDetails.from_json(json)
# print the JSON string representation of the object
print(ShipmentDetails.to_json())

# convert the object into a dict
shipment_details_dict = shipment_details_instance.to_dict()
# create an instance of ShipmentDetails from a dict
shipment_details_from_dict = ShipmentDetails.from_dict(shipment_details_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


