# CreditNoteDetails

References required in order to process a credit note. This information is required only if InvoiceType is CreditNote.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**reference_invoice_number** | **str** | Original Invoice Number when sending a credit note relating to an existing invoice. One Invoice only to be processed per Credit Note. This is mandatory for AP Credit Notes. | [optional] 
**debit_note_number** | **str** | Debit Note Number as generated by Amazon. Recommended for Returns and COOP Credit Notes. | [optional] 
**returns_reference_number** | **str** | Identifies the Returns Notice Number. Mandatory for all Returns Credit Notes. | [optional] 
**goods_return_date** | **datetime** | Defines a date and time according to ISO8601. | [optional] 
**rma_id** | **str** | Identifies the Returned Merchandise Authorization ID, if generated. | [optional] 
**coop_reference_number** | **str** | Identifies the COOP reference used for COOP agreement. Failure to provide the COOP reference number or the Debit Note number may lead to a rejection of the Credit Note. | [optional] 
**consignors_reference_number** | **str** | Identifies the consignor reference number (VRET number), if generated by Amazon. | [optional] 

## Example

```python
from py_sp_api.generated.vendorInvoices.models.credit_note_details import CreditNoteDetails

# TODO update the JSON string below
json = "{}"
# create an instance of CreditNoteDetails from a JSON string
credit_note_details_instance = CreditNoteDetails.from_json(json)
# print the JSON string representation of the object
print(CreditNoteDetails.to_json())

# convert the object into a dict
credit_note_details_dict = credit_note_details_instance.to_dict()
# create an instance of CreditNoteDetails from a dict
credit_note_details_from_dict = CreditNoteDetails.from_dict(credit_note_details_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


