# coding: utf-8

"""
    Selling Partner API for Retail Procurement Orders

    The Selling Partner API for Retail Procurement Orders provides programmatic access to vendor orders data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorOrders.models.acknowledgement_status_details import AcknowledgementStatusDetails
from py_sp_api.generated.vendorOrders.models.item_quantity import ItemQuantity
from typing import Optional, Set
from typing_extensions import Self

class OrderItemStatusAcknowledgementStatus(BaseModel):
    """
    Acknowledgement status information.
    """ # noqa: E501
    confirmation_status: Optional[StrictStr] = Field(default=None, description="Confirmation status of line item.", alias="confirmationStatus")
    accepted_quantity: Optional[ItemQuantity] = Field(default=None, alias="acceptedQuantity")
    rejected_quantity: Optional[ItemQuantity] = Field(default=None, alias="rejectedQuantity")
    acknowledgement_status_details: Optional[List[AcknowledgementStatusDetails]] = Field(default=None, description="Details of item quantity confirmed.", alias="acknowledgementStatusDetails")
    __properties: ClassVar[List[str]] = ["confirmationStatus", "acceptedQuantity", "rejectedQuantity", "acknowledgementStatusDetails"]

    @field_validator('confirmation_status')
    def confirmation_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ACCEPTED', 'PARTIALLY_ACCEPTED', 'REJECTED', 'UNCONFIRMED']):
            raise ValueError("must be one of enum values ('ACCEPTED', 'PARTIALLY_ACCEPTED', 'REJECTED', 'UNCONFIRMED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderItemStatusAcknowledgementStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of accepted_quantity
        if self.accepted_quantity:
            _dict['acceptedQuantity'] = self.accepted_quantity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of rejected_quantity
        if self.rejected_quantity:
            _dict['rejectedQuantity'] = self.rejected_quantity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in acknowledgement_status_details (list)
        _items = []
        if self.acknowledgement_status_details:
            for _item_acknowledgement_status_details in self.acknowledgement_status_details:
                if _item_acknowledgement_status_details:
                    _items.append(_item_acknowledgement_status_details.to_dict())
            _dict['acknowledgementStatusDetails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderItemStatusAcknowledgementStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "confirmationStatus": obj.get("confirmationStatus"),
            "acceptedQuantity": ItemQuantity.from_dict(obj["acceptedQuantity"]) if obj.get("acceptedQuantity") is not None else None,
            "rejectedQuantity": ItemQuantity.from_dict(obj["rejectedQuantity"]) if obj.get("rejectedQuantity") is not None else None,
            "acknowledgementStatusDetails": [AcknowledgementStatusDetails.from_dict(_item) for _item in obj["acknowledgementStatusDetails"]] if obj.get("acknowledgementStatusDetails") is not None else None
        })
        return _obj


