# coding: utf-8

"""
    Selling Partner API for Retail Procurement Orders

    The Selling Partner API for Retail Procurement Orders provides programmatic access to vendor orders data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorOrders.models.item_quantity import ItemQuantity
from py_sp_api.generated.vendorOrders.models.ordered_quantity_details import OrderedQuantityDetails
from typing import Optional, Set
from typing_extensions import Self

class OrderItemStatusOrderedQuantity(BaseModel):
    """
    Ordered quantity information.
    """ # noqa: E501
    ordered_quantity: Optional[ItemQuantity] = Field(default=None, alias="orderedQuantity")
    ordered_quantity_details: Optional[List[OrderedQuantityDetails]] = Field(default=None, description="Details of item quantity ordered.", alias="orderedQuantityDetails")
    __properties: ClassVar[List[str]] = ["orderedQuantity", "orderedQuantityDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderItemStatusOrderedQuantity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ordered_quantity
        if self.ordered_quantity:
            _dict['orderedQuantity'] = self.ordered_quantity.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in ordered_quantity_details (list)
        _items = []
        if self.ordered_quantity_details:
            for _item_ordered_quantity_details in self.ordered_quantity_details:
                if _item_ordered_quantity_details:
                    _items.append(_item_ordered_quantity_details.to_dict())
            _dict['orderedQuantityDetails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderItemStatusOrderedQuantity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "orderedQuantity": ItemQuantity.from_dict(obj["orderedQuantity"]) if obj.get("orderedQuantity") is not None else None,
            "orderedQuantityDetails": [OrderedQuantityDetails.from_dict(_item) for _item in obj["orderedQuantityDetails"]] if obj.get("orderedQuantityDetails") is not None else None
        })
        return _obj


