# coding: utf-8

"""
    Selling Partner API for Retail Procurement Orders

    The Selling Partner API for Retail Procurement Orders provides programmatic access to vendor orders data.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorOrders.models.item_quantity import ItemQuantity
from typing import Optional, Set
from typing_extensions import Self

class OrderItemStatusReceivingStatus(BaseModel):
    """
    Item receive status at the buyer's warehouse.
    """ # noqa: E501
    receive_status: Optional[StrictStr] = Field(default=None, description="Receive status of the line item.", alias="receiveStatus")
    received_quantity: Optional[ItemQuantity] = Field(default=None, alias="receivedQuantity")
    last_receive_date: Optional[datetime] = Field(default=None, description="The date when the most recent item was received at the buyer's warehouse. Must be in ISO-8601 date/time format.", alias="lastReceiveDate")
    __properties: ClassVar[List[str]] = ["receiveStatus", "receivedQuantity", "lastReceiveDate"]

    @field_validator('receive_status')
    def receive_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NOT_RECEIVED', 'PARTIALLY_RECEIVED', 'RECEIVED']):
            raise ValueError("must be one of enum values ('NOT_RECEIVED', 'PARTIALLY_RECEIVED', 'RECEIVED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderItemStatusReceivingStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of received_quantity
        if self.received_quantity:
            _dict['receivedQuantity'] = self.received_quantity.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderItemStatusReceivingStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "receiveStatus": obj.get("receiveStatus"),
            "receivedQuantity": ItemQuantity.from_dict(obj["receivedQuantity"]) if obj.get("receivedQuantity") is not None else None,
            "lastReceiveDate": obj.get("lastReceiveDate")
        })
        return _obj


