# Shipment

A list of one or more shipments with respective details.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**vendor_shipment_identifier** | **str** | Unique Transportation ID created by Vendor (Should not be used over the last 365 days). | 
**transaction_type** | **str** | Indicates the type of  transportation request such as (New,Cancel,Confirm and PackageLabelRequest). Each transactiontype has a unique set of operation and there are corresponding details to be populated for each operation. | 
**buyer_reference_number** | **str** | The buyer Reference Number is a unique identifier generated by buyer for all Collect/WePay shipments when you submit a transportation request. This field is mandatory for Collect/WePay shipments. | [optional] 
**transaction_date** | **datetime** | Date on which the transportation request was submitted. | 
**current_shipment_status** | **str** | Indicates the current shipment status. | [optional] 
**currentshipment_status_date** | **datetime** | Date and time when the last status was updated. | [optional] 
**shipment_status_details** | [**List[ShipmentStatusDetails]**](ShipmentStatusDetails.md) | Indicates the list of current shipment status details and when the last update was received from carrier this is available on shipment Details response. | [optional] 
**shipment_create_date** | **datetime** | The date and time of the shipment request created by vendor. | [optional] 
**shipment_confirm_date** | **datetime** | The date and time of the departure of the shipment from the vendor&#39;s location. Vendors are requested to send ASNs within 30 minutes of departure from their warehouse/distribution center or at least 6 hours prior to the appointment time at the Buyer destination warehouse, whichever is sooner. Shipped date mentioned in the shipment confirmation should not be in the future. | [optional] 
**package_label_create_date** | **datetime** | The date and time of the package label created for the shipment by buyer. | [optional] 
**shipment_freight_term** | **str** | Indicates if this transportation request is WePay/Collect or TheyPay/Prepaid. This is a mandatory information. | [optional] 
**selling_party** | [**PartyIdentification**](PartyIdentification.md) |  | 
**ship_from_party** | [**PartyIdentification**](PartyIdentification.md) |  | 
**ship_to_party** | [**PartyIdentification**](PartyIdentification.md) |  | 
**shipment_measurements** | [**TransportShipmentMeasurements**](TransportShipmentMeasurements.md) |  | [optional] 
**collect_freight_pickup_details** | [**CollectFreightPickupDetails**](CollectFreightPickupDetails.md) |  | [optional] 
**purchase_orders** | [**List[PurchaseOrders]**](PurchaseOrders.md) | Indicates the purchase orders involved for the transportation request. This group is an array create 1 for each PO and list their corresponding items. This information is used for deciding the route,truck allocation and storage efficiently. This is a mandatory information for Buyer performing transportation from vendor warehouse (WePay/Collect) | [optional] 
**import_details** | [**ImportDetails**](ImportDetails.md) |  | [optional] 
**containers** | [**List[Containers]**](Containers.md) | A list of the items in this transportation and their associated inner container details. If any of the item detail fields are common at a carton or a pallet level, provide them at the corresponding carton or pallet level. | [optional] 
**transportation_details** | [**TransportationDetails**](TransportationDetails.md) |  | [optional] 

## Example

```python
from py_sp_api.generated.vendorShipments.models.shipment import Shipment

# TODO update the JSON string below
json = "{}"
# create an instance of Shipment from a JSON string
shipment_instance = Shipment.from_json(json)
# print the JSON string representation of the object
print(Shipment.to_json())

# convert the object into a dict
shipment_dict = shipment_instance.to_dict()
# create an instance of Shipment from a dict
shipment_from_dict = Shipment.from_dict(shipment_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


