# ShipmentConfirmation

A list of one or more shipment confirmations.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**shipment_identifier** | **str** | Unique shipment ID (not used over the last 365 days). | 
**shipment_confirmation_type** | **str** | Indicates if this shipment confirmation is the initial confirmation, or intended to replace an already posted shipment confirmation. If replacing an existing shipment confirmation, be sure to provide the identical shipmentIdentifier and sellingParty information as in the previous confirmation. | 
**shipment_type** | **str** | The type of shipment. | [optional] 
**shipment_structure** | **str** | Shipment hierarchical structure. | [optional] 
**transportation_details** | [**TransportationDetailsForShipmentConfirmation**](TransportationDetailsForShipmentConfirmation.md) |  | [optional] 
**amazon_reference_number** | **str** | The Amazon Reference Number is a unique identifier generated by Amazon for all Collect/WePay shipments when you submit  a routing request. This field is mandatory for Collect/WePay shipments. | [optional] 
**shipment_confirmation_date** | **datetime** | Date on which the shipment confirmation was submitted. | 
**shipped_date** | **datetime** | The date and time of the departure of the shipment from the vendor&#39;s location. Vendors are requested to send ASNs within 30 minutes of departure from their warehouse/distribution center or at least 6 hours prior to the appointment time at the buyer destination warehouse, whichever is sooner. Shipped date mentioned in the shipment confirmation should not be in the future. | [optional] 
**estimated_delivery_date** | **datetime** | The date and time on which the shipment is estimated to reach buyer&#39;s warehouse. It needs to be an estimate based on the average transit time between ship from location and the destination. The exact appointment time will be provided by the buyer and is potentially not known when creating the shipment confirmation. | [optional] 
**selling_party** | [**PartyIdentification**](PartyIdentification.md) |  | 
**ship_from_party** | [**PartyIdentification**](PartyIdentification.md) |  | 
**ship_to_party** | [**PartyIdentification**](PartyIdentification.md) |  | 
**shipment_measurements** | [**ShipmentMeasurements**](ShipmentMeasurements.md) |  | [optional] 
**import_details** | [**ImportDetails**](ImportDetails.md) |  | [optional] 
**shipped_items** | [**List[Item]**](Item.md) | A list of the items in this shipment and their associated details. If any of the item detail fields are common at a carton or a pallet level, provide them at the corresponding carton or pallet level. | 
**cartons** | [**List[Carton]**](Carton.md) | A list of the cartons in this shipment. | [optional] 
**pallets** | [**List[Pallet]**](Pallet.md) | A list of the pallets in this shipment. | [optional] 

## Example

```python
from py_sp_api.generated.vendorShipments.models.shipment_confirmation import ShipmentConfirmation

# TODO update the JSON string below
json = "{}"
# create an instance of ShipmentConfirmation from a JSON string
shipment_confirmation_instance = ShipmentConfirmation.from_json(json)
# print the JSON string representation of the object
print(ShipmentConfirmation.to_json())

# convert the object into a dict
shipment_confirmation_dict = shipment_confirmation_instance.to_dict()
# create an instance of ShipmentConfirmation from a dict
shipment_confirmation_from_dict = ShipmentConfirmation.from_dict(shipment_confirmation_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


