# ShipmentInformation

Shipment Information details for Label request.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**vendor_details** | [**VendorDetails**](VendorDetails.md) |  | [optional] 
**buyer_reference_number** | **str** | The buyer reference number is a unique identifier generated by the buyer for all Collect and WePay shipments. | [optional] 
**ship_to_party** | [**PartyIdentification**](PartyIdentification.md) |  | [optional] 
**ship_from_party** | [**PartyIdentification**](PartyIdentification.md) |  | [optional] 
**warehouse_id** | **str** | Vendor Warehouse ID from where the shipment is scheduled to be picked up by buyer / Carrier. | [optional] 
**master_tracking_id** | **str** | Unique Id with  which  the shipment can be tracked for Small Parcels. | [optional] 
**total_label_count** | **int** | Number of Labels that are created as part of this shipment. | [optional] 
**ship_mode** | **str** | Type of shipment whether it is Small Parcel | [optional] 

## Example

```python
from py_sp_api.generated.vendorShipments.models.shipment_information import ShipmentInformation

# TODO update the JSON string below
json = "{}"
# create an instance of ShipmentInformation from a JSON string
shipment_information_instance = ShipmentInformation.from_json(json)
# print the JSON string representation of the object
print(ShipmentInformation.to_json())

# convert the object into a dict
shipment_information_dict = shipment_information_instance.to_dict()
# create an instance of ShipmentInformation from a dict
shipment_information_from_dict = ShipmentInformation.from_dict(shipment_information_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


