# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorShipments.models.purchase_order_items import PurchaseOrderItems
from typing import Optional, Set
from typing_extensions import Self

class PurchaseOrders(BaseModel):
    """
    Transport Request pickup date
    """ # noqa: E501
    purchase_order_number: Optional[StrictStr] = Field(default=None, description="Purchase order numbers involved in this shipment, list all the PO that are involved as part of this shipment.", alias="purchaseOrderNumber")
    purchase_order_date: Optional[datetime] = Field(default=None, description="Purchase order numbers involved in this shipment, list all the PO that are involved as part of this shipment.", alias="purchaseOrderDate")
    ship_window: Optional[StrictStr] = Field(default=None, description="Date range in which shipment is expected for these purchase orders.", alias="shipWindow")
    items: Optional[List[PurchaseOrderItems]] = Field(default=None, description="A list of the items that are associated to the PO in this transport and their associated details.")
    __properties: ClassVar[List[str]] = ["purchaseOrderNumber", "purchaseOrderDate", "shipWindow", "items"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PurchaseOrders from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item_items in self.items:
                if _item_items:
                    _items.append(_item_items.to_dict())
            _dict['items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PurchaseOrders from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "purchaseOrderNumber": obj.get("purchaseOrderNumber"),
            "purchaseOrderDate": obj.get("purchaseOrderDate"),
            "shipWindow": obj.get("shipWindow"),
            "items": [PurchaseOrderItems.from_dict(_item) for _item in obj["items"]] if obj.get("items") is not None else None
        })
        return _obj


