# coding: utf-8

"""
    Selling Partner API for Retail Procurement Shipments

    The Selling Partner API for Retail Procurement Shipments provides programmatic access to retail shipping data for vendors.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from py_sp_api.generated.vendorShipments.models.label_data import LabelData
from py_sp_api.generated.vendorShipments.models.shipment_information import ShipmentInformation
from typing import Optional, Set
from typing_extensions import Self

class TransportLabel(BaseModel):
    """
    A list of one or more ShipmentLabels.
    """ # noqa: E501
    label_create_date_time: Optional[datetime] = Field(default=None, description="Date on which label is created.", alias="labelCreateDateTime")
    shipment_information: Optional[ShipmentInformation] = Field(default=None, alias="shipmentInformation")
    label_data: Optional[List[LabelData]] = Field(default=None, description="Indicates the label data,format and type associated .", alias="labelData")
    __properties: ClassVar[List[str]] = ["labelCreateDateTime", "shipmentInformation", "labelData"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransportLabel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of shipment_information
        if self.shipment_information:
            _dict['shipmentInformation'] = self.shipment_information.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in label_data (list)
        _items = []
        if self.label_data:
            for _item_label_data in self.label_data:
                if _item_label_data:
                    _items.append(_item_label_data.to_dict())
            _dict['labelData'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransportLabel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "labelCreateDateTime": obj.get("labelCreateDateTime"),
            "shipmentInformation": ShipmentInformation.from_dict(obj["shipmentInformation"]) if obj.get("shipmentInformation") is not None else None,
            "labelData": [LabelData.from_dict(_item) for _item in obj["labelData"]] if obj.get("labelData") is not None else None
        })
        return _obj


